-- usdLua.lua

local usdLua_lua_version = 36

if tonumber('zzzzzzzz',36)~=2821109907455 then plg.msg('Old lua5.1.dll !') end

--usd.savetolog( ('os.setlocale: %s'):format(os.setlocale("")) ) --    
function debugLog(str) if usd.fdebug then usd.savetolog(str) end end

package.cpath = usd.workdir .. [[Lua\?.dll;]] .. package.cpath	--   dll  Lua\

bit = require("bit")	--    http://bitop.luajit.org/

zlib = require("zlib")	-- http://luaforge.net/projects/lzlib/

lpeg = require'lpeg'	-- Parsing Expression Grammars For Lua
debugLog('LPeg v'..lpeg.version())

re   = require're'		-- http://www.inf.puc-rio.br/~roberto/lpeg/lpeg.html
lpeg.setmaxstack(150)
lpeg.locale(lpeg)

ascii85 = require'ascii85'	-- http://www.tecgraf.puc-rio.br/~lhf/ftp/lua/  http://luarocks.org/repositories/rocks/

struct = require 'struct'	-- http://www.inf.puc-rio.br/~roberto/struct/

--openssl = require 'openssl' -- https://github.com/zhaozg/lua-openssl/ --    >40 
ltn12ce = require 'ltn12ce.core'	-- https://github.com/mkottman/ltn12ce/

base64 = require("base64")


--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------

USD_SETCOOKIE_APPEND = 0
USD_SETCOOKIE_OVERWRITE = 1

--plg.msg
-- 
MB_OK               = 0x0
MB_OKCANCEL         = 0x1
MB_ABORTRETRYIGNORE = 0x2
MB_YESNOCANCEL      = 0x3
MB_YESNO            = 0x4
MB_RETRYCANCEL      = 0x5
-- 
MB_ICONHAND         = 0x10
MB_ICONSTOP         = MB_ICONHAND
MB_ICONERROR        = MB_ICONHAND
MB_ICONQUESTION     = 0x20
MB_ICONEXCLAMATION  = 0x30
MB_ICONWARNING      = MB_ICONEXCLAMATION
MB_ICONASTERISK     = 0x40
MB_ICONINFORMATION  = MB_ICONASTERISK
-- 
IDOK                = 1
IDCANCEL            = 2
IDABORT             = 3
IDRETRY             = 4
IDIGNORE            = 5
IDYES               = 6
IDNO                = 7
IDCLOSE             = 8
IDHELP              = 9

--plg.recode
CP_ACP				= 0
CP_OEMCP			= 1
CP_UTF8				= 65001
CP_WINUNICODE		= 1200

MAX_PATH			= 260


SW_HIDE             = 0
SW_SHOWNORMAL       = 1
SW_NORMAL           = 1
SW_SHOWMINIMIZED    = 2
SW_SHOWMAXIMIZED    = 3
SW_MAXIMIZE         = 3
SW_SHOWNOACTIVATE   = 4
SW_SHOW             = 5
SW_MINIMIZE         = 6
SW_SHOWMINNOACTIVE  = 7
SW_SHOWNA           = 8
SW_RESTORE          = 9
SW_SHOWDEFAULT      = 10
SW_MAX              = 10
SW_FORCEMINIMIZE    = 11

SND_ALIAS       = 0x10000
SND_ALIAS_ID    = 0x110000
SND_ALIAS_START = 0x0
SND_APPLICATION = 0x80
SND_ASYNC       = 0x1
SND_FILENAME    = 0x20000
SND_LOOP        = 0x8
SND_MEMORY      = 0x4
SND_NODEFAULT   = 0x2
SND_NOSTOP      = 0x10
SND_PURGE       = 0x40
SND_RESOURCE    = 0x40004
SND_SYNC        = 0x0
SND_TYPE_MASK   = 0x170007
SND_VALID       = 0x1F
SND_VALIDFLAGS  = 0x17201F

SND_ALIAS_START				= 0
SND_ALIAS_SYSTEMASTERISK	= 0x00002A53
SND_ALIAS_SYSTEMDEFAULT		= 0x00004453
SND_ALIAS_SYSTEMEXCLAMATION	= 0x00002153
SND_ALIAS_SYSTEMEXIT		= 0x00004553
SND_ALIAS_SYSTEMHAND		= 0x00004853
SND_ALIAS_SYSTEMQUESTION	= 0x00003F53
SND_ALIAS_SYSTEMSTART		= 0x00005353
SND_ALIAS_SYSTEMWELCOME		= 0x00005753

WM_USER 		= 0x400
CCM_FIRST 		= 0x2000
CCM_SETBKCOLOR	= CCM_FIRST+1
PBM_SETBARCOLOR	= WM_USER+9
PBM_SETBKCOLOR	= CCM_SETBKCOLOR
PBM_SETMARQUEE	= WM_USER+10
PBM_SETPOS		= WM_USER+2
PBM_SETRANGE32	= WM_USER+6
PBM_SETSTEP		= WM_USER+4
PBM_STEPIT		= WM_USER+5
PBS_MARQUEE		= 8
PBS_SMOOTH		= 1

CLR_DEFAULT		= 0xFF000000

local tmpData = {
	getLstInfoCache = nil
    , getMirrorUrl = nil
}


local function readIni()
	local tbl, section = {}
	local ln = 0
	for line in io.lines(usd.workdir .. plg.exename .. '.ini') do if not line:find('^%s*$') and not line:find('^%s*;') then
		ln = ln+1
		if line:find('^%[(.-)%]$') then
			local tmp = line:match('^%[(.-)%]$'):lower()
			local s1, s2 = tmp:match('^(plugin)_(.+)$')
			s1 = s1 or tmp
			tbl[s1] = tbl[s1] or {}
			section = tbl[s1]
	        if s2 then
				tbl[s1][s2] = tbl[s1][s2] or {}
				section = tbl[s1][s2]
	        end
		else
			--local name, value = line:match('^([^=]+)=(.*)$')
			local name, value = line:match('^%s*([^=]-)%s*=%s*(.-)%s*$')
			if not (name and value) then
				usd.savetolog('Bad line '..ln..' in '..plg.exename..'.ini: >'..line..'<')
			else
				name = name:lower()
				local n1, n2 = name:match('^item(%d+)_?(.-)$')
				n1 = n1 and tonumber(n1)
				n2 = n2 or (value:find('^http') and 'url' or '_')
				value = value ~= '' and value --   = false
				if n1 then
					section[n1] = section[n1] or {}
					section[n1][n2] = value
				else
					section[name] = value
				end
			end
		end
	end end
	return tbl
end


local tmpUsd = usd
tmpUsd.ini = readIni()

--local tmpHttp = http

--usdIni = readIni()
--if tmpHttp then
--tmpHttp.USERAGENT = usd.ini.main.useragent
--tmpHttp.PROXY = usd.ini.proxy.usehttpproxy == '1' and ('http://'..usd.ini.httpproxy.address..':'..usd.ini.httpproxy.port..'/')
--end

math.randomseed(os.time()); math.random(); math.random(); math.random(); -- skip first numbers

function utf8ToAnsi(str)
	return plg.recode(CP_UTF8, CP_ACP, str)
end

--       (  ).
function pad(str, len, symb)
	str = tostring(str)
	symb = symb or '0'
	return symb:rep(len-#str) .. str
end

function tableCopy(tbl)
	local r = {}
	for k, v in pairs(tbl) do
		r[k] = type(v)=='table' and tableCopy(v) or v
	end
	return r
end

function tableCombine(base, new)
	local r = tableCopy(base)
	for k, v in pairs(new) do
		r[k] = type(v)=='table' and tableCombine(type(r[k])=='table' and r[k] or {}, v) or v
	end
	return r
end

function tableKeys(...)
	local tbl = {}
	for k,v in pairs(arg) do tbl[v] = v end
	return tbl
end

function tableConcat(tbl, sepKV, sepPairs, encode)
	sepKV = sepKV or ''
	sepPairs = sepPairs or ''
	local r = {}
	for k, v in pairs(tbl) do
		if encode then
			k = encode(k)
			v = encode(v)
		end
		table.insert(r, tostring(k)..sepKV..tostring(v))
	end
	return table.concat(r, sepPairs)
end

function tableGetKeys(tbl)
	local tmp = {}
	for k, v in pairs(tbl) do table.insert(tmp,k) end
	return tmp
end

function tableGetValues(tbl)
	local tmp = {}
	for k, v in pairs(tbl) do table.insert(tmp,v) end
	return tmp
end


---       
--- t1 = counters.test;  t2 = counters.test;  counters.set('test',123);  t3 = counters.test;  counters.reset();  t4 = counters.test;  t5 = counters.test
--- plg.msg('t1='..t1..', t2='..t2..', t3='..t3..', t4='..t4..', t5='..t5) -- t1=1, t2=2, t3=123, t4=1, t5=2
counters = (function(tbl)
		local proxy = {} -- http://www.lua.org/pil/13.4.5.html
		proxy.reset = function() for k,v in pairs(tbl) do tbl[k]=nil end end
		proxy.set = function(cnt, val)
			if (type(cnt)~='string' or cnt=='set' or cnt=='reset') then
				error("Invalid counter name: '"..tostring(cnt).."'")
			elseif (type(val)~='number' and type(val)~='nil') then
				error("Invalid type '"..type(val).."' for counter '"..tostring(cnt).."'")
			else
				tbl[cnt]=val
			end
		end
		local mt = {
			__index = function(t,k)
				local a = tbl[k] or 1
				--if type(a)=='number' then tbl[k] = a+1 end
				tbl[k] = a+1
				return a
			end
			--,__newindex = function(t,k,v)  tbl[k]=v  end
		}
		setmetatable(proxy, mt)
		return proxy
	end){};

--    
-- fname -    ;     
-- cnt -    counters
-- digs -    digs 
----
-- getNextName('for_debug.html', counters.debugSave) --> 'for_debug_01.html'
-- getNextName('for_debug.html', counters.debugSave, 4) --> 'for_debug_0002.html'
function getNextName(fname, cnt, digs)
	digs = digs or 2
	local name, ext = string.match(fname, '^(.+)(%.[^%.]+)$')
	name = name or fname
	ext = ext or ''
	return name .. '_' .. pad(cnt,digs) .. ext
end


function debugSave(fName, data, str, addinfo)
	if type(fName) ~= 'string' or #fName==0 or type(data) ~= 'string' then error('debugSave: fName or data is not string!') end
	if usd.fdebug then
		usd.savetolog('debugSave: '..fName)
		if str then
			str = tostring(str)
			if #str<137 then
				usd.savetolog(str)
			elseif str:find('^{') or str:find('^[^\r\n]*[\r\n]+{') then
				usd.savetolog( (str:match('^([^\r\n]*[\r\n]+){') or '') .. '[long string]')
			else
				usd.savetolog(str:sub(1,130)..'... [cut]')
			end
			--usd.savetolog(#str<137 and str or str:sub(1,130)..'...[cut]')
		end
		local info = (addinfo or type(addinfo) == 'nil') and ('<pre>\r\nsize: '..#data..'\r\n\r\n'..(str and str..'\r\n\r\n' or '')..usd.getheaders() .. '\r\nCookie: '..usd.getcookie()..'\r\n</pre>\r\n\r\n') or ''
		usd.savetofile(usd.workdir .. fName, info .. data)
	end
end

function debugSaveInc(fName, data, str, addinfo)
	debugSave(getNextName(fName, counters.debugSave), data, str, addinfo)
	return
end


function unescape(s)	-- LuaSocket \socket\url.lua
    return (string.gsub(s, "%%(%x%x)", function(hex)
        return string.char(tonumber(hex, 16))
    end))  -- http://www.luafaq.org/gotchas.html 8.1
end


--  encodeURI -- javascript:prompt('',encodeURI('`-=~!@#$%^&*()_+[]{};\':",./<>?\\|'))
-- %60-=~!@#$%25%5E&*()_+%5B%5D%7B%7D;':%22,./%3C%3E?%5C%7C
function escapeU(s)
    return (string.gsub(s, "([^A-Za-z0-9=~!@#$&*()_+;:,./?-])", function(c)
        return string.format("%%%02x", string.byte(c))
    end)) -- http://www.luafaq.org/gotchas.html 8.1
end

--  encodeURIComponent -- javascript:prompt('',encodeURIComponent('`-=~!@#$%^&*()_+[]{};\':",./<>?\\|'))
function escapeUC(s)
    return (string.gsub(s, "([^A-Za-z0-9%-%.%*_!~()])", function(c)
        return string.format("%%%02x", string.byte(c))
    end)) -- http://www.luafaq.org/gotchas.html 8.1
end

function entityDecode(str, toAnsi)
	local entities = {	--   UTF-8
		  --nbsp = ' ', [160] = ' ' --   --   utf8
		  nbsp	= n2utf8(160), iexcl	= n2utf8(161), cent		= n2utf8(162), pound	= n2utf8(163), curren	= n2utf8(164)
		, yen	= n2utf8(165), brvbar	= n2utf8(166), sect		= n2utf8(167), uml		= n2utf8(168), copy		= n2utf8(169)
		, ordf	= n2utf8(170), laquo	= n2utf8(171), ['not']	= n2utf8(172), shy		= n2utf8(173), reg		= n2utf8(174)
		, macr	= n2utf8(175), deg		= n2utf8(176), plusmn	= n2utf8(177), sup2		= n2utf8(178), sup3		= n2utf8(179)
		, acute	= n2utf8(180), micro	= n2utf8(181), para		= n2utf8(182), middot	= n2utf8(183), cedil	= n2utf8(184)
		, sup1	= n2utf8(185), ordm		= n2utf8(186), raquo	= n2utf8(187), frac14	= n2utf8(188), frac12	= n2utf8(189)
		, frac34= n2utf8(190), iquest	= n2utf8(191), Agrave	= n2utf8(192), Aacute	= n2utf8(193), Acirc	= n2utf8(194)
		, Atilde= n2utf8(195), Auml		= n2utf8(196), Aring	= n2utf8(197), AElig	= n2utf8(198), Ccedil	= n2utf8(199)
		, Egrave= n2utf8(200), Eacute	= n2utf8(201), Ecirc	= n2utf8(202), Euml		= n2utf8(203), Igrave	= n2utf8(204)
		, Iacute= n2utf8(205), Icirc	= n2utf8(206), Iuml		= n2utf8(207), ETH		= n2utf8(208), Ntilde	= n2utf8(209)
		, Ograve= n2utf8(210), Oacute	= n2utf8(211), Ocirc	= n2utf8(212), Otilde	= n2utf8(213), Ouml		= n2utf8(214)
		, times	= n2utf8(215), Oslash	= n2utf8(216), Ugrave	= n2utf8(217), Uacute	= n2utf8(218), Ucirc	= n2utf8(219)
		, Uuml	= n2utf8(220), Yacute	= n2utf8(221), THORN	= n2utf8(222), szlig	= n2utf8(223), agrave	= n2utf8(224)
		, aacute= n2utf8(225), acirc	= n2utf8(226), atilde	= n2utf8(227), auml		= n2utf8(228), aring	= n2utf8(229)
		, aelig	= n2utf8(230), ccedil	= n2utf8(231), egrave	= n2utf8(232), eacute	= n2utf8(233), ecirc	= n2utf8(234)
		, euml	= n2utf8(235), igrave	= n2utf8(236), iacute	= n2utf8(237), icirc	= n2utf8(238), iuml		= n2utf8(239)
		, eth	= n2utf8(240), ntilde	= n2utf8(241), ograve	= n2utf8(242), oacute	= n2utf8(243), ocirc	= n2utf8(244)
		, otilde= n2utf8(245), ouml		= n2utf8(246), divide	= n2utf8(247), oslash	= n2utf8(248), ugrave	= n2utf8(249)
		, uacute= n2utf8(250), ucirc	= n2utf8(251), uuml		= n2utf8(252), yacute	= n2utf8(253), thorn	= n2utf8(254)
		, yuml	= n2utf8(255)
		, quot  = '"'
		, rdquo = '"'
		, ldquo = '"'
		, bdquo = '"'
		, apos   = "'"
		, rsquo  = "'"
		, lsquo  = "'"
		, sbquo  = "'"
		, amp = '&'
		, lt = '<'
		, gt = '>'
		, lsaquo = '<'
		, rsaquo = '>'
		, bull = '*', [8226] = '*'
		, [9679] = '*'
		, ndash = '-', [8211] = '-'
		, mdash = '-', [8212] = '-'
		, hellip = '...'
		, frasl = '/'
		, [8203] = ''	-- Zero Width Space
	}
	return (string.gsub(str,'&(#?)(x?)([%w]+);', function(n,x,w)
		local num = tonumber(w, x=='x' and 16 or 10)
		local tmp
		if n == '#' and num then
			tmp = entities[num] or n2utf8(num)
		else
			tmp = entities[x..w] or '&'..n..x..w..';'
		end
		return toAnsi and utf8ToAnsi(tmp) or tmp
	end))
end


--http://lua-users.org/wiki/RandomStrings
local Chars = {}
for Loop = 0, 255 do
   Chars[Loop+1] = string.char(Loop)
end
local String = table.concat(Chars)
local Built = {['.'] = Chars}
local AddLookup = function(CharSet)
   local Substitute = string.gsub(String, '[^'..CharSet..']', '')
   local Lookup = {}
   for Loop = 1, string.len(Substitute) do
       Lookup[Loop] = string.sub(Substitute, Loop, Loop)
   end
   Built[CharSet] = Lookup
   return Lookup
end
function randomString(Length, CharSet)
   -- Length (number)
   -- CharSet (string, optional); e.g. %l%d for lower case letters and digits
   local CharSet = CharSet or '.'
   if CharSet == '' then
      return ''
   else
      local Result = {}
      local Lookup = Built[CharSet] or AddLookup(CharSet)
      local Range = #Lookup
      for Loop = 1,Length do
         Result[Loop] = Lookup[math.random(1, Range)]
      end
      return table.concat(Result)
   end
end




plg.tHosts     = {}	--     PlgInit -     
--  - ,  - 
plg.tDirLink   = {}	--      
plg.tOnSuccess = {}
plg.tOnCheck   = {}
plg.tOnError   = {}
plg.tDestroy   = {}

--[[
regDirSuccess    
urlPart -  , 
fnDirLink -    , 
fnOnSuccess -     , ;      
]]
function regDirSuccess(urlPart, fnDirLink, fnOnSuccess)
	if type(urlPart) == 'table' then
		for k, v in pairs(urlPart) do regDirSuccess(v, fnDirLink, fnOnSuccess) end
		return
	end

	if type(urlPart) ~= 'string' or #urlPart < 5 then
		error("regDirSuccess error: urlPart must be a string of at least 5 characters: '" .. (urlPart or '') .. "'", 2) end
	if type(fnDirLink) ~= 'function' or type(fnOnSuccess) ~= 'function' and type(fnOnSuccess) ~= 'nil' then
		error('regDirSuccess error: fnDirLink must be a function, fnOnSuccess must be a function or nil', 2) end
	if not plg.tDirLink[urlPart] then table.insert(plg.tHosts, urlPart) end  --     
	if plg.tDirLink[urlPart] then    debugLog('Warning: tDirLink[urlPart] exist:    '..urlPart) end
	if plg.tOnSuccess[urlPart] then  debugLog('Warning: tOnSuccess[urlPart] exist:  '..urlPart) end
	plg.tDirLink[urlPart]   = fnDirLink;
	plg.tOnSuccess[urlPart] = fnOnSuccess;
	if Settings and Settings['<misc>'] and Settings['<misc>'].logSupportedHosts then debugLog('        '..urlPart) end
end

--[[
regCheckError    
dirUrlPart -   / , 
]]
function regCheckError(dirUrlPart, fnOnCheck, fnOnError)
	if type(dirUrlPart) == 'table' then
		for k, v in pairs(dirUrlPart) do regCheckError(v, fnOnCheck, fnOnError) end
		return
	end

	if type(dirUrlPart) ~= 'string' or #dirUrlPart < 5 then
		error("regCheckError error: dirUrlPart must be a string of at least 5 characters '" .. (dirUrlPart or '') .. "'", 2) end
	if type(fnOnCheck) ~= 'function' and type(fnOnCheck) ~= 'nil' or type(fnOnError) ~= 'function' and type(fnOnError) ~= 'nil' then
		error('regCheckError error: fnOnCheck and fnOnError must be a function or nil', 2) end
	if plg.tOnCheck[dirUrlPart] then debugLog('Warning: tOnCheck[dirUrlPart] exist: '..dirUrlPart) end
	if plg.tOnError[dirUrlPart] then debugLog('Warning: tOnError[dirUrlPart] exist: '..dirUrlPart) end
	plg.tOnCheck[dirUrlPart] = fnOnCheck;
	plg.tOnError[dirUrlPart] = fnOnError;
end

--[[
regDestroy     plg.tDestroy,   
  ;   1   
]]
function regDestroy(fnDestroy)
	if type(fnDestroy) ~= 'function' then
		error('regDestroy error: fnDestroy must be a function', 2) end
	--local _ = getfenv(2)
	--local sn = _.script and _.script.name
	local sn = getfenv(2).script.name
	plg.tDestroy[sn] = fnDestroy
end

--  PlgInit    USD  
function PlgInit()
	usd.setretresult(table.concat(plg.tHosts, '\n') .. '|1036')
end

function getHandler(tbl,u)
	u = string.lower(u)
	for k, v in pairs(tbl) do
		if string.find(u, k:lower(), 1, true) then
			return tbl[k], k
		end
	end
end

--local getMirrorUrl
--local getLstInfoCache

local function GDLinit(ini)
	debugLog( ('os.setlocale: %s'):format(os.setlocale('C')) )
	usd.relocationmode(1)
	usd.setretresult('')

	usd.setreferer('')
	usd.setcookie('')
	local sm = Settings['<misc>']
	if type(sm.extIPservices)=='table' then sm.extIP = sm.extIPservices[math.random(#sm.extIPservices)] end
	if sm.crutchHttp then
		debugLog('crutchHttp')
		usd.get(Settings['<misc>'].crutchHttp)
		usd.get(Settings['<misc>'].crutchHttp)
		usd.setreferer('')
		usd.setcookie('')
	end

	--usd.get('http://0.0.0.0/headers/')
	if ini then
		tmpData = {}
		--tmpData.getLstInfoCache = nil
		--tmpData.getMirrorUrl = false
		tmpUsd.ini = readIni()
		if tmpHttp then
			tmpHttp.USERAGENT = usd.ini.main.useragent
			tmpHttp.PROXY = usd.ini.proxy.usehttpproxy == '1' and ('http://'..usd.ini.httpproxy.address..':'..usd.ini.httpproxy.port..'/')
		end
	end
end

--  tDirLink    
function PlgGetDirectLink(origUrl)
	counters.reset()
	GDLinit(true)
	--tmpData.getMirrorUrl = false
	debugLog('usdLua.lua version = ' .. usdLua_lua_version)
	debugLog('somelibrary version = '..(somelibrary_version or 'none'))
--usd.waittime(1)
	-- origUrl = URI.recode(origUrl, true)
	local GetDirectLinkHandler = getHandler(plg.tDirLink, origUrl)
	if GetDirectLinkHandler then
		local fn = debug.getfenv(GetDirectLinkHandler).script
		debugLog('GDL: ' .. (fn and fn.fullname or '<no script.fullname>') )
		GetDirectLinkHandler(origUrl)

		--usd.setretresult('%Server report: You need wait ' .. (h*60+m)*60+s .. ' seconds')
		local r = plg.getretresult()	-- 
		local wait = r:match('^%%Server report: You need wait (%d+) seconds')
		if wait and tonumber(wait) <= plg.config.maxwait then
			usd.setstatus(r)
			debugLog('plg.config.maxwait='..plg.config.maxwait..', '..r)
			usd.setretresult('')
			usd.waittime(wait+2)
			if usd.progstatus() == 0 then
				debugLog('USD stopped')
				return
			end
			GDLinit(false)
			GetDirectLinkHandler(origUrl)
		end

		--if r == '' then usd.waittime(10) end
		r = plg.getretresult()	-- 
		local c = Settings['<misc>'] and Settings['<misc>'].saveCookiesTo
		if r:find('^https?://') and c then
			debugLog('Saving cookies into '..c)
			local h, err = io.open(c, 'wb')
			if h then
				h:write(usd.getcookie())
				h:close()
			else
				usd.savetolog(err)
			end
		end

		return
	end
	error('PlgGetDirectLink handler not found: ' .. origUrl) --  - ,  USD   :-)
end

local OCfullNamePusd

function PlgOnSuccess(origUrl, dirUrl, fullName)
	usd.setretresult('');

	debugLog('usd.progstatus()='..usd.progstatus());
	debugLog('PlgOnSuccess origUrl='..origUrl);
	--origUrl = URI.recode(origUrl, true)

	if tmpData.getMirrorUrl then
		debugLog('        getMirrorUrl='..tmpData.getMirrorUrl);
	end
	debugLog('PlgOnSuccess dirUrl='..dirUrl);
	debugLog('PlgOnSuccess fullName='..fullName);

	local OCfullName = OCfullNamePusd:match('^(.-)%.pusd$')
	local size = fileSize(OCfullName) -- exist?

	--if size and Settings['<misc>'].fixOSfullName and OCfullName ~= fullName then
	if not size then
		debugLog('not exist? ok')
	elseif size and OCfullName ~= fullName then
		fullName = OCfullName
		debugLog('fixed fullName       ='..OCfullName)
		usd.setretresult(OCfullName)
	end

	debugLog('usd.progstatus()='..usd.progstatus());
	local OnSuccessHandler = getHandler(plg.tOnSuccess, origUrl)
	if OnSuccessHandler then
		local fn = debug.getfenv(OnSuccessHandler).script
		debugLog('OS: ' .. (fn and fn.fullname or '<no script.fullname>') )
--usd.waittime(1)
		OnSuccessHandler(origUrl, dirUrl, fullName)
	end
	local OnSuccessHandlerMirror
	if tmpData.getMirrorUrl then
		OnSuccessHandlerMirror = getHandler(plg.tOnSuccess, tmpData.getMirrorUrl)
		if OnSuccessHandlerMirror and OnSuccessHandlerMirror ~= OnSuccessHandler then
			debugLog('Calling OnSuccess for '..tmpData.getMirrorUrl)
			OnSuccessHandlerMirror(tmpData.getMirrorUrl, dirUrl, fullName)
		end
		tmpData.getMirrorUrl = false
	end
	if OnSuccessHandler or OnSuccessHandlerMirror then return end
	debugLog('usdLua.lua: PlgOnSuccess handler not found')
	return
end

function PlgOnError(dirUrl, errMsg, data)
	--usd.setretresult(1,10);
	usd.setretresult('');

	debugLog('PlgOnError: dirUrl='..dirUrl)
	debugLog('PlgOnError: errMsg='..errMsg)
	if data:find('[%z\001-\008\011\012\014-\031]') then
		debugLog('PlgOnError: data=<binary garbage>')
	elseif #data>128 then
		debugLog('PlgOnError: data=<html data>')
		debugSave(os.date('err-%y%m%d-%H%M%S-') .. counters.err .. '.htm', data, nil, false)
	else
		debugLog('PlgOnError: data='..data)
	end
	local OnErrorHandler = getHandler(plg.tOnError, dirUrl)
	if OnErrorHandler then
		local fn = debug.getfenv(OnErrorHandler).script
		debugLog('OE: '..(fn and fn.fullname or '<no script.fullname>') )
		--usd.waittime(1)
		OnErrorHandler(dirUrl, errMsg, data)
		return
	end
	debugLog('usdLua.lua: PlgOnError handler not found')
	--usd.setstatus('PlgOnError')
	usd.waittime(10)
	return
end

function PlgOnCheck(dirUrl, fullName, headers, currStatus)
	usd.setretresult('');

	OCfullNamePusd = fullName
	debugLog('PlgOnCheck: dirUrl = '..dirUrl)
	debugLog('        fullName   = '..fullName)
	debugLog('        headers    = '..headers)
	debugLog('        currStatus = '..currStatus)

	-- 2GB
	local hl = headers:lower()
	local fSize = tonumber( hl:match('[\r\n]content%-range: bytes %d+%-%d+/(%d+)')   or hl:match('[\r\n]content%-length: (%d+)') )
	if fSize and fSize>0 and currStatus==1 then
		if fSize == fileSize(fullName) then
			debugLog(fSize.. ': sizes match, set status 2')
			usd.setretresult(2)
		end
	end

	local OnCheckHandler = getHandler(plg.tOnCheck, dirUrl)
	if OnCheckHandler then
		local fn = debug.getfenv(OnCheckHandler).script
		debugLog('OC: '..(fn and fn.fullname or '<no script.fullname>'))
		--usd.waittime(1)
		OnCheckHandler(dirUrl, fullName, headers, currStatus)
		return
	end
	debugLog('usdLua.lua: PlgOnCheck handler not found')
	return
end

function PlgDestroy()
	usd.savetolog('PlgDestroy start')
	for k, v in pairs(plg.tDestroy) do
		usd.savetolog('PlgDestroy: ' .. k)
		local status, err = pcall(v)
		if not status then usd.savetolog(err) end
	end
	usd.savetolog('PlgDestroy end')
end

----------------------------------------------------------------------------------------------------------------------------

do -- http://lua-users.org/wiki/StringTrim
 local ptrim = re.compile"%s* {(%s* %S+)*}"
 local match = lpeg.match
 function trim(s)
   return match(ptrim, s)
 end
end


function split(str, sep, func)	-- http://www.inf.puc-rio.br/~roberto/lpeg/lpeg.html
	if sep=='' then return lpeg.match(lpeg.Ct(lpeg.C(lpeg.P(1))^0), str) end
	sep = lpeg.P(sep)
	local elem = func and (lpeg.C((1 - sep)^0) / func) or lpeg.C((1 - sep)^0)
	local p = lpeg.Ct(elem * (sep * elem)^0)   -- make a table capture
	return lpeg.match(p, str)
end


function splitKV(str, sepKV, sepP, func)	-- http://www.inf.puc-rio.br/~roberto/lpeg/
	func = func or rawset
	local space = lpeg.space^0
	local empty = lpeg.C('')
	local name = lpeg.C((1-lpeg.S(sepKV..sepP))^1) * space
	local value = (lpeg.C((1-lpeg.S(sepP))^1) + empty )* space
	local pair = lpeg.Cg(name * lpeg.S(sepKV)^0 * space * value) * (lpeg.S(sepP) * space)^0
	local list = lpeg.Cf(lpeg.Ct("") * pair^0, func)
	return list:match(str)
end


--  
function filterName(str,noSpaces)
	if not str then return '' end
	if type(str) ~= 'string' then error('filterName error: str must be string; type='..type(str), 2) end
	--local truncSpaces   = '^%s*(.-)%s*$'
	-- '+', ';'  : USD 1.3.5.6    
	local replaceChars  = '[^%w--%%%.%-%[%]\'\32`~!@#$%^&()_={}\,.]+'
	local replaceSymbol = '_'
	str = str or ''
	local tmp = entityDecode(str, true)
	tmp = tmp:gsub('%s+',' '):gsub('["<>]',"'")
	--tmp = tmp:match(truncSpaces):gsub(replaceChars, replaceSymbol)
	tmp = trim(tmp):gsub(replaceChars, replaceSymbol)
	if noSpaces then tmp=tmp:gsub('[%s_\']+','_'):gsub('_?%-_?','-'):gsub('^%-', '_-') end
	return tmp
end

-- oldFullName -    , newName -    , newExt -     ()
--  ,     
function fileRename(oldFullName, newName, newExt, prefix)
	if type(oldFullName) ~= 'string' or #oldFullName==0 then
		error('fileRename error: oldFullName must be non-empty string', 2) end
	debugLog('fileRename oldFullName='..oldFullName)
	if newName then debugLog('newName='..newName) end
	if newExt then debugLog('newExt='..newExt) end
	if prefix then debugLog('prefix='..prefix) end
	if not (newName or newExt or prefix) then return oldFullName end --   
	if newName == '' then newName = nil end --    true
	local path, fname = string.match(oldFullName, '^(.*\\)([^\\]*)$')
	local name, ext = string.match(fname, '^(.-)(%.[^.]+)$')

	if not newExt then	--  newExt=nil,  newName -    .
		local _
		_, newExt = (newName or ''):match('^(.-)(%.[^.]+)$')
		if newExt
			and #newExt >= 2
			and #newExt <= 5
			then
			newName = _
		else
			newExt = nil
		end
	elseif newExt == -1 then
		newExt = ext
	end


	name = newName or name or fname
	ext = newExt or ext or ''
	prefix = prefix or ''
	name = filterName(name)
	ext = filterName(ext)
	if prefix then filterName(prefix):sub(1,128) end
	if #path + #prefix + #name + #ext > MAX_PATH - 10 then --  '[2221]'      :-)
		name = name:sub(1, (MAX_PATH - 10 - #path - #ext) ) --  
		if (#path + #prefix + #name + #ext > MAX_PATH - 10) or name=='' then error('Too long path or newExt!') end
	end

	local newFullName = path .. prefix .. name .. ext

	if plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,oldFullName))==plg.lowerW(plg.recode(CP_ACP,CP_WINUNICODE,newFullName))
		then return oldFullName end --   

	local tmp = {}
	for i = 2, 2222 do
		if i == 2222 then error('Too many files!') end
		tmp = { io.open(newFullName, 'r') } --     : nil, ,  
		if #tmp ~= 1 and tmp[3]==2 then -- 2=No such file or directory
			break
		end
		io.close(tmp[1])
		newFullName = path .. prefix .. name .. '[' .. pad(i, 2) .. ']' .. ext
	end

	tmp = {os.rename(oldFullName, newFullName)}
	if #tmp >1 then error('Rename error: ' .. tmp[2]) end
	usd.savetolog('fileRename end:        '..newFullName)
	return newFullName
end

function fileSize(fname)
	if type(fname) ~= 'string' then
		debugLog('fileSize: fname is not a string!')
		return
	end
	-- 2GB
	--local h, err = io.open(fname, 'rb')
	--if h then
	--	local size = h:seek('end')
	--	h:close()
	--	return size
	--end
	--debugLog(err)
	--return nil, err
	local size, err = plg.filesize(fname)
	if err then debugLog(err) end
	return size, err
end

function fileRead(fname)
	local h, err = io.open(fname, 'rb')
	if h then
		local contents = h:read('*a')
		h:close()
		return contents
	end
	usd.savetolog(err)
	return nil, err
end

function fileWrite(fname, ...)
	local h, err = io.open(fname, 'wb')
	if h and select(1,...) then
		local contents = h:write(...)
		h:close()
		return true
	elseif not err and not select(1,...) then
		err = 'no data'
	end
	usd.savetolog('fileWrite: '..err)
	return nil, err
end

function fileAppend(fname, ...)
	local h, err = io.open(fname, 'ab')
	if h and select(1,...) then
		local contents = h:write(...)
		h:close()
		return true
	elseif not err and not select(1,...) then
		err = 'no data'
	end
	usd.savetolog('fileAppend: '..err)
	return nil, err
end

------------------------------------------------------------------------------------------------------------------------

--       strgood   strbad
function tryDl(url, post, tries, strgood, strbad)
	tries = tries or 5  --    
	strgood = strgood or '' --    
	local p
	local function checkStr(flag,str,mode)
		mode = (mode=='and' or mode=='or') and mode or 'or'
		if mode=='and' then
			flag = flag and p:find(str)
		else
			flag = flag or p:find(str)
		end
		return flag
	end
	local function checkTable(tbl)
		local flagOr, flagAnd = false, true
		if tbl.a then  for k,v in pairs(tbl.a) do  flagAnd=checkStr(flagAnd, v,'and')  end  end
		if tbl.o then  for k,v in pairs(tbl.o) do  flagOr =checkStr(flagOr , v,'or' )  end  end
		if tbl.a and not tbl.o then flagOr=true end
		if not (tbl.a or tbl.o) then
			for k, v in pairs(tbl) do  flagOr = checkStr(flagOr, v)  end
		end
		return flagOr and flagAnd
	end

	for i=1, tries do
		debugLog('tryDl attempt '..i)
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		p = (post and usd.post(url,post) or usd.get(url))
--debugSaveInc('tryDl_'..i..'.html', p)

		local good, bad = true, false

		if type(strgood)=='function' then
			good, bad = strgood(p)
		else
			if type(strgood)=='table' then  good = checkTable(strgood)  else  good = p:find(strgood)  end
			if type(strbad)=='table' then  bad = checkTable(strbad)  elseif strbad then  bad = p:find(strbad)   end
		end

		if good and not bad then return p end

		usd.waittime(2)
	end
	return nil, p
end

function trySubmit(form, subm, tries, strgood, strbad)
	debugLog('trySubmit:')
	local req = form:getinputs(subm or false)	-- clickX, clickY
	if form.method == 'POST' then
		return tryDl(form.action, req, tries, strgood, strbad)
	else
		return tryDl(form.action:gsub('%?.*$','')..'?'..req, tries, strgood, strbad)
	end
end

------------------------------------------------------------------------------------------------------------------------

--    '?/pref-name-suff.fext'  ""
function addNewName(orig,name,pref,suff,fext,sep)
	if not (name or pref or suff or fext) then return orig end
	local get = orig:match('(%?.*)$')
	orig = orig:match('^([^?]+)')
	sep = filterName(sep or '-')
	pref = pref and filterName(pref) .. sep or ''
	suff = suff and sep .. filterName(suff) or ''
	local fname = orig:match('/([^/]+)$') or ''

	if not fext then
		local newExt = filterName( (name or ''):match('^.-(%.[^.]+)$') )
        if newExt
			and #newExt >= 2
			and #newExt <= 5
			then
			fext = newExt
			name = name:match('^(.-)%.[^.]+$') or name
		else
			fext = filterName(fname:match('(%.[^.]+)$') or '')
		end
	elseif fext==-1 then
		fext = filterName( fname:match('^.-(%.[^.]+)$') )
	end

	fname = filterName(name or fname:match('^(.-)%.[^.]+$') or fname)
	return (orig .. (get and get..'&/' or '?/') .. ( pref .. fname .. suff .. fext ):gsub('%s','_'):gsub('%%','%%25'):gsub('_?%-_?','-'))
end

------------------------------------------------------------------------------------------------------------------------

local imageTypes = tableKeys('jpeg', 'png', 'gif', 'bmp')

function queryCaptchaOCR(cfile, timeout, ctype, manual, host, noUniversal)
	local captcha
	ctype = ctype:gsub('_v%d+$','')				-- script version
	debugLog('ctype = ' .. ctype .. ', cfile = ' .. cfile)
	if cfile:find('%s') then
		local m = 'Put the USD to the directory without spaces >:->'
		usd.savetolog(m)
		usd.setstatus(m)
	end
	local cfileType
	cfile, cfileType = plg.setproperext(cfile)
	if not cfile then error(cfileType) end

	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end
	local host2 = host:gsub('([%-%+%*()%%%[%].])','%%%1')

	local OCR = Captchas[host]
	if OCR then
		debugLog('ctype = host')
	else
		OCR = Captchas[ctype]
	end
	if noUniversal then
		debugLog('queryCaptchaOCR: noUniversal flag')
	elseif not OCR and Captchas['_Universal_'] then
		OCR = Captchas['_Universal_']
		debugLog('queryCaptchaOCR: using _Universal_')
	end

	local start = os.time()

	debugLog('queryCaptchaOCR: host = ' .. host)
	if not manual and OCR and OCR.ocrOnly and host then
		if not ('>'..OCR.ocrOnly..'<'):find('%W'..host2..'%W') then
			debugLog('queryCaptchaOCR: host is not found in the list "ocrOnly"')
			manual = true
		end
	elseif not manual and OCR and OCR.skipHosts and host then
		if ('>'..OCR.skipHosts..'<'):find('%W'..host2..'%W') then
			debugLog('queryCaptchaOCR: host is found in the list "skipHosts"')
			manual = true
		end
	end

	if not OCR then	debugLog('queryCaptchaOCR: captcha type "' .. host .. '" or "'.. ctype ..'" is not found in captchas.lua') end
	if manual then debugLog('queryCaptchaOCR: manual flag') end

	if OCR and OCR.ocrCmd and not manual then
		local sw = OCR.sw or SW_SHOWMINNOACTIVE
		local cmd = OCR.ocrCmd .. ' ' .. cfile
		local exitcode, err = plg.exec(cmd, true, sw)
		if exitcode and string.lower(OCR.result)=='clipboard' then
			captcha = usd.getclipboard()
		elseif exitcode then
			captcha, err = fileRead(OCR.result)
			if err then
				usd.savetolog('queryCaptchaOCR error: '..err)
			end
		end
		captcha = trim(captcha or '')
		usd.savetolog('captcha = ' .. captcha or '')
		if captcha==''
			or (OCR.min and OCR.min > #captcha)
			or (OCR.max and OCR.max < #captcha)
			then
			usd.savetolog('OCR error'..(
				((OCR.min and ('; min='..OCR.min) or '') .. (OCR.max and ('; max='..OCR.max) or '') )
				or '')
			)
		elseif captcha then
			usd.waittime(math.random(5,12)-(os.time()-start))
			--     
			timeout = timeout - (os.time() - start)
			return captcha, timeout
		end
	end
	timeout = timeout - (os.time() - start)

	if OCR and OCR.noFallback and not manual then
		return '', timeout
	end

	if not imageTypes[cfileType] then
		usd.savetolog('queryCaptchaOCR: unknown captcha type')
		return '', timeout
	end

	local tstart = os.clock()
	captcha, timeout = usd.showhawindow(cfile, timeout)
	if captcha=='' and (os.clock() - tstart < 1.5) then		--    Enter    1.5 
		captcha, timeout = usd.showhawindow(cfile, timeout)
	end
	return captcha, timeout
end

function queryCaptcha(url, timeout, ctype, manual, host, noUniversal)
	timeout = timeout or 0
	--local logpref = _.logpref or (_.script and _.script.name..'_' or '')..'captcha'
	--ctype = ctype or (_.script.name:gsub('_v%d+$',''))
	local _ = getfenv(2) if not (_.logpref or _.script) then _ = getfenv(3) end
	local logpref = _.logpref or (_.script and _.script.name..'_' or '') ..'captcha'
	ctype = ctype or _.script.name
	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end
	local oldref = usd.getlocation()
	local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
	--usd.get(url .. '|' .. cfile)
	tryDl(url .. '|' .. cfile, nil, nil, 'Done')
	local captcha
	captcha, timeout = queryCaptchaOCR(cfile, timeout, ctype, manual, host, noUniversal)
	usd.setreferer(oldref)
	return captcha, timeout
end

function queryReCaptcha(key, timeout, manual, host, noUniversal, check, reload)
	local conf = Captchas['reCaptcha'] or {}
	local data -- key, timeout, manual, host, noUniversal, check, reload
	if type(key)=='table' then
		data = key
	else
		data = {key=key, timeout=timeout, manual=manual, host=host, noUniversal=noUniversal, check=check, reload=reload}
	end
	debugLog('queryReCaptcha: data = '..serialize(data))
	debugLog('queryReCaptcha: conf = '..serialize(conf))
	if data.reload==nil then data.reload = conf.reload end

	data.timeout = data.timeout or 0
	local _ = getfenv(2) if not (_.logpref or _.script) then _ = getfenv(3) end
	local logpref = _.logpref or (_.script and _.script.name..'_' or '') ..'recaptcha'
	if not data.host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		data.host = getHost(origUrl)
	end
	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	local server = 'http://www.google.com/recaptcha/api/'
	usd.setreferer(server)
	usd.setcookie('')
	local rcUrl = server .. (data.check and 'noscript' or 'challenge') .. '?k=' .. data.key
	local rc, challenge, captcha, cfile, form
	rc = usd.get(rcUrl)
	debugSaveInc(logpref .. '.html', rc)
	local start = os.time()
	local wait
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	if not data.check then
		server = rc:match("server : '([^']+)',")
		challenge = rc:match("challenge : '([^']+)',")
		if data.reload then
			local tmp = usd.get(('%sreload?c=%s&k=%s&reason=r&type=image&lang=en'):format(server,challenge,data.key))
			debugSaveInc(logpref .. '.html', tmp)
			challenge = tmp:match("finish_reload%('([^']+)'")
			usd.setreferer(server)
		end
		cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
		usd.get(server .. 'image?c=' .. challenge .. '|' .. cfile)
		captcha, data.timeout = queryCaptchaOCR(cfile, data.timeout, 'reCaptcha', data.manual, data.host, data.noUniversal)
	else
		captcha = ''
		local attempts = tonumber(data.check) or conf.tries or captchaAttempts
		if attempts < 1 then attempts = 1 end
		for i=1, attempts do
			local start2 = os.time()
			--rc = usd.get(rcUrl)
			--debugSaveInc(logpref .. '.html', rc)
			form = Form.parse(rc:match('<form.-</form>'))
			form.action = rcUrl
			cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
			challenge = form.inputs.recaptcha_challenge_field
			if usd.progstatus() == 0 then return debugLog('USD stopped') end
			if data.reload then
				local tmp = usd.get(('%sreload?c=%s&k=%s&reason=r&type=image&lang=en'):format(server,challenge,data.key))
				debugSaveInc(logpref .. '.html', tmp)
				challenge = tmp:match("finish_reload%('([^']+)'")
				form.inputs.recaptcha_challenge_field = challenge
				usd.setreferer(server)
			end
			usd.get(server .. 'image?c=' .. challenge .. '|' .. cfile)
			form.inputs.recaptcha_response_field, data.timeout
				= queryCaptchaOCR(cfile, data.timeout, 'reCaptcha', data.manual, data.host, data.noUniversal)
			rc = form:submit()
			debugSaveInc(logpref .. '.html', rc)
			if rc:find('</textarea></body></html>') then
				challenge = rc:match('<textarea[^>]+>([^<]+)</textarea></body></html>')
				captcha = 'manual_challenge'
				break
			end
			usd.waittime(start2+7-os.time())
		end
	end
	usd.waittime(start+10-os.time())
	usd.setreferer(oldref)
	usd.setcookie(oldCookies)
	return captcha, data.timeout, challenge
end


function querySolvemedia(key, timeout, manual, host, noUniversal, check)
	timeout = timeout or 0
	local stopAfterTimeout
	if type(timeout)=='table' then
		timeout=timeout[1]
		stopAfterTimeout = true
	end
	--local _ = getfenv(2)
	--local logpref = _.logpref or (_.script and _.script.name..'_' or '')..'solvemedia'
	local _ = getfenv(2) if not (_.logpref or _.script) then _ = getfenv(3) end
	local logpref = _.logpref or (_.script and _.script.name..'_' or '') ..'solvemedia'
	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end
	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	usd.setcookie('')

	local attempts = not check and 1 or tonumber(check) or captchaAttempts
	if attempts < 1 then attempts = 1 end
	local form
	for i=1, attempts do
		if stopAfterTimeout and timeout<1 then break end
		usd.setreferer(oldref)
		local sm = usd.get('http://api.solvemedia.com/papi/challenge.noscript?k='..key)
		debugSaveInc(logpref .. '.html', sm)

		local cimg = 'http://api.solvemedia.com' .. sm:match('<img[^>]-src="(/papi/media%?[^"]+)"')
		local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		usd.get(cimg .. '|' .. cfile)

		form = sm:match('<form.-</form>')
		form = Form.parse(form)
		if not form.action:find('://') then
			form.action = 'http://api.solvemedia.com/papi/' .. form.action
		end
		form.inputs.adcopy_response
			, timeout = queryCaptchaOCR(cfile, timeout, 'solvemedia', manual, host, noUniversal)
		sm = form:submit()
		debugSaveInc(logpref .. '.html', sm)

		if sm:find('/verify.pass.') then
			sm = usd.get('http://api.solvemedia.com/papi/verify.pass.noscript?c='..form.inputs.adcopy_challenge)
			debugSaveInc(logpref .. '.html', sm)
			break
		end
	end

	usd.setreferer(oldref)
	usd.setcookie(oldCookies)

	if stopAfterTimeout and timeout<1 then
		debugLog('Timeout - stop')
		return '', timeout, ''
	end

	return 'manual_challenge', timeout, form.inputs.adcopy_challenge

end


function queryAdsCaptcha(url, timeout, manual, host, noUniversal)
	timeout = timeout or 0
	--local _ = getfenv(2)
	--local logpref = _.logpref or (_.script and _.script.name..'_' or '')..'adscaptcha'
	local _ = getfenv(2) if not (_.logpref or _.script) then _ = getfenv(3) end
	local logpref = _.logpref or (_.script and _.script.name..'_' or '') ..'adscaptcha'
	if not host then
		local origUrl, origUrl = debug.getlocal(2,1) --  >:-)
		host = getHost(origUrl)
	end
	local oldref = usd.getlocation()
	local oldCookies = usd.getcookie()
	usd.setcookie('')

    url = url:lower():gsub('/get%.aspx%?','/NoScript.aspx?')

	local captcha

	local ac = usd.get(url)
	debugSaveInc(logpref .. '.html', ac)

	local cimg = ac:match('(http://api.adscaptcha.com/+Challenge.aspx[^%s"\']+)')

	local challenge = cimg:match('cid=([^&]+)')
	local cfile = usd.workdir .. getNextName(logpref .. '.ext', counters.debugSave)
	if usd.progstatus() == 0 then return debugLog('USD stopped') end
	usd.get(cimg .. '|' .. cfile)
	captcha, timeout = queryCaptchaOCR(cfile, timeout, 'adsCaptcha', manual, host, noUniversal)

	usd.setreferer(oldref)
	usd.setcookie(oldCookies)
	return captcha, timeout, challenge
end


------------------------------------------------------------------------------------------------------------------------


function getMirror(mirrors, preferred, interactive, rows, unwanted)
	local conf = Settings and Settings['<getMirror>']
	if not conf then
		debugLog("No Settings['<getMirror>'] - using default...")
		conf = {
			interactive = false,
			useMega = false,
			preferred = {
				'sendfile.su'
				, 'rapidshare.com'
				, 'hu.lk', 'hulkshare.com'
				, '1fichier.com'
				, 'verzend.be'
				, 'depositfiles.com'
				, 'mediafire.com'
				, 'jumbofiles.com'
				, 'uploading.com'
			}
			, unwanted = {
				  'extabit.com'
				, 'hitfile.net'
			}
			, paidshit = {
			}
		}
	end
	preferred = preferred or conf.preferred or {}
	unwanted = unwanted or conf.unwanted or {}
	interactive = interactive and conf.interactive

	local function checkMega(url)
		debugLog('checkMega: '..url)
		local isNode, fileId, fileKey = (url or ''):match('^https?://mega%.co%.nz/#(N?)!(.-)!(.+)$')
		if not fileId then return end
		local page = usd.post('https://g.api.mega.co.nz/cs?id=1', '[{"a":"g","ssl":"0","g":"1","'..(isNode=='N' and 'n' or 'p')..'":"'..fileId..'"}]')
		debugSaveInc('checkMega.html', page)
		local flag = not not page:find('"g":"http://')
		debugLog(flag and 'checkMega: exists' or 'checkMega: some problem')
		return flag
	end


	local hnames = {}				-- ,      preferred/unwanted
	local tmp = {}
	local mirrorsCount = 0
	local shitlist = ','..table.concat(conf.paidshit or {},',')..','
	local megaconz
	for k, v in pairs(mirrors) do
		v = trim(v)
		local url = URI.parse(v)
		if (url and url.host and url.scheme and (url.scheme:find('^https?$') or url.scheme=='ftp')) then
			if url.scheme:find('^https?$') then url.scheme = 'http' end
			local h = getHost(url)
			if type(k) == 'number' then	--   - ,    
				k = h
			end
			--if shitlist:find(','..getHost(url):gsub('%-','%%-')..',') then
			if shitlist:find(','..h:gsub('([%-%+%*()%%%[%].])','%%%1')..',') then
				debugLog('Skip shit: '..v)
			elseif h == 'mega.co.nz' then
				url.scheme = 'http'
				megaconz = url(nil, true)
				local GDLhandler, h = getHandler(plg.tDirLink, megaconz)
				if conf.useMega and GDLhandler and checkMega(megaconz) then
					debugLog('Using Mega...')
					local info = getLstInfo()
					local pusdsize = 0
					if info and info.localfile then
						pusdsize = fileSize(info.localfile..'.pusd') or 0
					end
					if pusdsize == 0 then
						debugLog('Change url...')
						usd.modquery(megaconz)
						GDLhandler(megaconz)
						return
					else
						debugLog("Can't use Mega: this file has already been partially downloaded!")
					end
				else
					debugLog('Skip '..v)
				end

			else
				tmp[k] = url(nil, true) --          :-)
				mirrorsCount = mirrorsCount + 1
				table.insert(hnames, k)
			end
		else
			usd.savetolog('getMirror: bad mirror: '..tostring(v))
		end
	end
	mirrors = tmp

	if usd.progstatus()==0 then
		usd.setretresult('')
		debugLog('getMirror: USD stopped 1')
		return
	end

	if #hnames==0 then
    	if megaconz then
    		usd.modquery(megaconz)
			local GDLhandler, h = getHandler(plg.tDirLink, megaconz)
			if GDLhandler then GDLhandler(megaconz) end
    		return
    	end
		usd.savetolog('Empty mirrors table!')
--debugSaveInc('getMirrors-err.html', '')
		usd.setretresult('%notfound%')
		return false, '', {}
	end

	local minwait = false
	local notfound = false

	--   (true  )
	local getdirect = function(url)
		local GDLhandler, h = getHandler(plg.tDirLink, url)
		if GDLhandler then
			if h then debugLog('-- substring: '..h) end
			GDLinit(false)
			local status, err = pcall(GDLhandler, url)
			if not status then
				debugLog(err)
				--debugSave(os.date('getMirror-err-%y%m%d-%H%M%S-') .. counters.getMirrorErr .. '.htm', url .. '\r\n\r\n' .. err, err, false)
				return false
			end
			local r = plg.getretresult()
			debugLog('result: '..r)

			if  (r:lower() == '%done%')
				or (r~=''  and  not r:find('^%%')  and  r:find('://')) then 		--   
				return true
			else
				local wait = r:match('^%%Server report: You need wait (%d+) seconds')
				if wait then
					wait = tonumber(wait)
					minwait = math.min(minwait or wait, wait)
				elseif r == '%notfound%' or r == '%deleted%' then
					notfound = (notfound or 0) + 1
				end
				--return false
			end
		end
		return false
	end

	--debugLog('Mirrors:          '..table.concat(hnames, ', '))
	debugLog('Mirrors:')
	for k, v in pairs(mirrors) do
		debugLog(v)
	end

	local unsupported = {}

	--     (type = 'select')   
	if (preferred and #preferred>0) or (unwanted and #unwanted>0) then
		local tmp = {}
		--  
		for i=1, #preferred do
			for k, v in pairs(hnames) do
				if v == preferred[i] and getHandler(plg.tDirLink, mirrors[v]) then
					table.insert(tmp, v)
					hnames[k] = nil
				end
			end
		end

		local tmpUnw = ',' .. table.concat(unwanted, ',') .. ','

		--  
		for k, v in pairs(hnames) do
			if not tmpUnw:find(','..v..',',1,true) and getHandler(plg.tDirLink, mirrors[v]) then
				table.insert(tmp, v)
				hnames[k] = nil
			end
		end

		--  
		for k, v in pairs(hnames) do
			if getHandler(plg.tDirLink, mirrors[v]) then
				table.insert(tmp, v)
				hnames[k] = nil
			end
		end

		local uList = {}
		for k, v in pairs(hnames) do
			table.insert(uList, v)
			unsupported[v] = mirrors[v]
		end
		if #uList>0 then
			debugLog( 'Unsupported: ' .. table.concat(uList, ', ') )
		end

		hnames = tmp
	end

	debugLog( 'Filtered mirrors: ' .. table.concat(hnames, ', ') )

	if #hnames == 0 then
		local err = '%No script handlers'
		usd.setretresult(err)
		return false, err, unsupported
	end

	if interactive then
		local dlg = Dialog.new(rows)
		dlg:addrows({
            {'__________________________'}
            , {'Select mirror:'}
            , {{type='select', name='host', hnames }}
		})
		local _ = getfenv(2)
		dlg:makeform(_.script and _.script.name or '<getMirror>')
		local h = dlg:show()
        if h == '' then return end		-- esc
        h = h:match('host=([%d]+)') + 1	--     0
        local m = mirrors[hnames[h]]
        --if getdirect(m) then return true, m end --  
		--m = URI.recode(m)
        if getdirect(m) then			--  
        	tmpData.getMirrorUrl = m
        	return true, 'http://fakemirror/'
        end
		hnames[h] = false				--  
	end

	--    
	for i, v in ipairs(hnames) do
		if usd.progstatus()==0 then break end
		local m = mirrors[v]
		--if m and getdirect(m) then return true, m end
        if m and getdirect(m) then
        	tmpData.getMirrorUrl = m
        	return true, 'http://fakemirror/'
        end
	end

	usd.setretresult('')

	if usd.progstatus()==0 then
		debugLog('getMirror: USD stopped 2')
		return
	end

	local _
	if minwait then
		_ = '%Server report: You need wait ' .. minwait .. ' seconds'
	elseif notfound == mirrorsCount
		or notfound == #hnames and megaconz
		then
		if notfound == #hnames then debugLog('Supported mirrors are dead') end
		if megaconz and checkMega(megaconz) then
			local info = getLstInfo()
			local pusdsize = 0
			if info and info.localfile then
				pusdsize = fileSize(info.localfile..'.pusd') or 0
			end
			if pusdsize == 0 then
				debugLog('Change url...')
				usd.modquery(megaconz)
				usd.setretresult('%Restarting...', 5)
			else
				usd.setretresult('%Delete .pusd')
			end
			return
		end
		usd.savetolog('All mirrors are dead')
		_ = '%notfound%'
	elseif notfound == #hnames then
		_ = '%Supported mirrors are dead'
	else
		_ = '%getMirror error'
	end
	debugLog('#hnames='..#hnames .. ' notfound='..(notfound or 0) )
	usd.setretresult(_)
	return false, _, unsupported
end

------------------------------------------------------------------------------------------------------------------------

Form={}
Form.__index = Form

Form.fp = re.compile([[
		form	<- '<'[fF][oO][rR][mM] garbage attrs '/'? '>' ([^<]+ / comment / input / button / !('</' [fF][oO][rR][mM] garbage '>') .)* '</' [fF][oO][rR][mM] garbage '>'
		comment <- '<!--' (!'-->' .)* '-->'
		input	<- '<'[iI][nN][pP][uU][tT] garbage attrs '/'? '>'
		button	<- '<'[bB][uU][tT][tT][oO][nN] garbage attrs '/'? '>'
		attrs	<- (attr garbage)*  -> tokeyval
		garbage <- ['"%s]*
		attr	<- ( { aname } %s* '=' %s* str / { aname }{''})
		aname	<- %a[%w-]*
		str		<- '"' { [^"]* } '"' / "'" { [^']* } "'" / { [^%s>]+ }
	]]
	, {
		tokeyval = function(...)	--   key=value   
				local t = {}
				for i=1, #arg, 2 do
					t[arg[i]:lower()]=arg[i+1]	-- key   
				end
				return t
			end
	})

function Form.parse(form)
	local string, table = string, table
	if type(form) ~= 'string' then error('The argument must be a string!',2) end

   	local fpr = {}
	re.gsub(form, Form.fp, function(...)
		table.insert(fpr,{...})
		return ''
	end)

	local function parse2(fpr)
		if #fpr==0 then return end
		local f = {}
   		setmetatable(f, Form.__index)
		f.enctype = string.lower(fpr[1].enctype or '')
		if f.enctype ~= 'multipart/form-data' then f.enctype = 'application/x-www-form-urlencoded' end
		f.method = string.upper(fpr[1].method or '')
		if f.method ~= 'POST' then f.method = 'GET' end
		f.action = fpr[1].action or ''
		f.inputs = {}
		f.submits = {}
		local fi, fs = f.inputs, f.submits

		for i=2, #fpr do
			local t = fpr[i]
			if t.name == '' then t.name = nil end
			if t.type then t.type = string.lower(t.type) end

			if t.type == 'reset' or (not t.name and t.type ~= 'image') then
			elseif t.type == 'submit' then
				fs[t.name] = t.value or 'Submit'
			elseif t.type == 'image' then
				local coords = {x=0,y=0,src=t.src}
				if t.name then
					fs[t.name] = coords
				else
					table.insert(fs, coords)
				end
			elseif (t.type == 'checkbox' or t.type == 'radio') then
				if t.checked then
					fi[t.name] = t.value or 'on'
				end
			else
				fi[t.name] = t.value or ''
			end
		end

	   	return f
	end
	for fpri=1, #fpr do fpr[fpri]=parse2(fpr[fpri]) end

	return unpack(fpr)
end

function Form.make(tbl)
	local f = {}
   	setmetatable(f, Form.__index)
	f.action = tbl.action or ''
	f.enctype = string.lower(tbl.enctype or '')
	if f.enctype ~= 'multipart/form-data' then f.enctype = 'application/x-www-form-urlencoded' end
	f.method = string.upper(tbl.method or '')
	if f.method ~= 'POST' then f.method = 'GET' end
	f.inputs = tableCopy(tbl.inputs or {})
	f.submits = tableCopy(tbl.submits or {})
	return f
end

function Form:escape(str)
	return tostring(str):gsub('[^%da-zA-Z_.-]',function(c)
		if c==' ' then return '+' end
		return '%'..bit.tohex(c:byte(),2)
	end)
end

--   
--    ,   submit 
--     
function Form:getinputs(sname, clickX, clickY)
	local t={}
	for k, v in pairs(self.inputs) do
		table.insert(t, self:escape(k)..'='..self:escape(v))
	end
	local submit = (tostring(sname)~='nil' or clickX or clickY) and self:getsubmit(sname, clickX, clickY)
	if submit then table.insert(t, submit) end
	local simple = self.method == 'POST' and self.enctype~='multipart/form-data' and '%simple%' or ''
	return simple .. table.concat(t, '&')
end

--     nil
function Form:getsubmit(sname, clickX, clickY)
	local s
	local sk, sv = next(self.submits)	--   
	if sname and self.submits[sname] or not sname then --      nil/false
		sk = sname or sk
		sv = self.submits[sname] or sv
		if type(sv)=='table' then -- image
			local pref = type(sk)=='number' and '' or self:escape(sk)..'.'
			s = pref..'x='..(clickX or sv.x).. '&' .. pref..'y='..(clickY or sv.y)
		else
			s = sk and sv and self:escape(sk)..'='..self:escape(sv)
		end
	end
	return s
end

function Form:submit(sname, clickX, clickY)
	local req = self:getinputs(sname or false, clickX, clickY)
	if self.method == 'POST' then
		return usd.post(self.action, req)
	else
		return usd.get(self.action:gsub('%?.*$','')..'?'..req)
	end
end

------------------------------------------------------------------------------------------------------------------------

Dialog = {}
Dialog.__index = Dialog

function Dialog.new(rows, caption, width, fontHeight)
	local dlg = {rows={}, form='', fontHeight=fontHeight or plg.config.fontheight}
	local sd = Settings['<Dialog>']
	if sd then
		dlg.sound = sd.sound
		dlg.soundflags = sd.soundflags
		dlg.beep = sd.beep
	end

   	setmetatable(dlg, Dialog.__index)
	if rows then
		dlg:addrows(rows)
		dlg:makeform(caption, width)
	end
	return dlg
end

function Dialog:addrows(rows)
	for i=1, #rows do
		self:addrow(rows[i])
	end
end

function Dialog:addrow(...)
	if #arg == 0 then return end

	if #arg==1 and (type(arg[1])=='table' and not arg[1].type) then
		arg = arg[1]
	end

	local WW, WH = plg.gettextextent('W', self.fontHeight)
	local top, left = 0, 0

    local parserow = function(row)
		if type(row)~='string' and type(row)~='table' then error('Argument must be a table or string: '..tostring(row)) end
		local width, height = 0, 0
		local str = ''

		if type(row) == 'string' then
			row = {type='label', row}
		end

		if type(row[1]) == 'string' then
			str = (row[1]:gsub('[\r\n|]+',' '))
			width, height = plg.gettextextent(str, self.fontHeight)
		end

		if row.type then row.type = string.lower(row.type) end

		if row.type == 'label' then
			width  = math.max(width, row.width or 0)
			height = math.max(height, row.height or 0)
			local l = {type='label', width=width, height=height, value=str, top=top, left=left}
			left = left + width
			if #str>2 and not str:find('[^_]') then
				l.top = l.top - math.floor(WH/2)
			end
			return l
		end

		local r = {type=row.type
				 , width=math.max(width, row.width or 0)
				 , height=math.max(height, row.height or 0)
				 , name=row.name
				 , value=row.value or 0
				 , top=top
				 , left=left
				 }

		if row.type == 'checkbox' then
			r.width = r.width + WW*2
			r.caption = str
			left = left + r.width
			return r
		end

		if row.type == 'edit' or row.type == 'password' then
			r.height = r.height + math.floor(WH/2)
			r.width = r.width + WW
			r.value = str
			if not r.value then r.value='' end
			left = left + r.width
			return r, true
		end

		if row.type == 'select' then
			if type(row[1])~='table' then error('Items for "select" must be a table!') end
			r.width = WW
			r.height = WH
			local items = {}
			for i=1, #row[1] do
				str = (row[1][i]:gsub('[\r\n|]+',' '))
				local w, h = plg.gettextextent(str, self.fontHeight)
				r.width = math.max(r.width,w)
				r.height = math.max(r.height,h)
				r['item'..i]=str
			end
			r.width = r.width + WW*3
			r.height = r.height + WH
			left = left + r.width
			return r, true
		end

		error('Unknown type: '..tostring(row.type))
	end

	local parsed = {}
	local flag
	for i=1, #arg do
		local r, f = parserow(arg[i])
		flag = flag or f
		table.insert(parsed, r)
	end

	if flag then	--    edit/password/select
		for i=1, #parsed do
			if parsed[i].type == 'label' or parsed[i].type == 'checkbox' then
				parsed[i].top = parsed[i].top + math.floor(WW/2)
			end
		end
	end

	table.insert(self.rows, parsed)
	return

end


function Dialog:makeform(capt, width)

	local scrleft, scrtop, scrright, scrbottom = plg.gettextextent()
	local maxWidth, maxHeight = math.floor((scrright-scrleft)*0.9), math.floor((scrbottom-scrtop)*0.9)
	width = tonumber(width or 0)
	local offH, offV = 5, 5		-- offset
	local caption = plg.plgname .. '.plg / ' .. (capt or '.lua')
	local captionW, captionH = plg.gettextextent(caption, self.fontHeight)
	local WW, WH = plg.gettextextent('W', self.fontHeight)
	local top = offV
	local left = offH
	local widthItems = 0

	local form = {}
	for i=1, #self.rows do
		local rWidth, rHeight = 0, 0
		for j=1, #self.rows[i] do
			local r = tableCopy(self.rows[i][j])
			rHeight = math.max(rHeight, r.top + r.height)
			r.top = r.top + top
			r.left = r.left + left + WW*(j-1)
			rWidth = r.left + r.width
			--table.insert(form, tableConcat(r, '|'))
			table.insert(form, tableConcat(r, '=', '|'))
		end
		top = top + rHeight + math.floor(WH/2)
		widthItems = math.max(widthItems, rWidth)
	end

	local formW = math.max(300, math.min( maxWidth, (math.max(captionW, widthItems, width) + offH*3 ) ) )
	local formH = math.max(120, math.min( maxHeight, captionH + top + WH*4 ) )
	table.insert(form, 1, 'type=form|width='..formW..'|height='..formH..'|caption='..caption)

	self.form=table.concat(form, '\n')
	return
end

function Dialog:show()
	if self.sound then plg.playsound(self.sound, 0, self.soundflags) end
	if self.beep then playbeep(self.beep) end
	local _ = usd.simpleoptions(self.form)
	if self.sound then plg.playsound() end	-- stop sound
	return _
end


------------------------------------------------------------------------------------------------------------------------

function prompt(msg, text, caption, width)
	d = Dialog.new({
		{msg or 'Prompt'}
		, {type='edit', name='prompt', width=width or 300, text}
		}, caption)
	local p = d:show()
	if p == '' then return nil end
	--return (p:gsub('^prompt=%s*',''):gsub('[\r\n%s]*$','')) -- gsub  2 !
	return (p:gsub('^prompt=%s*(.-)%s*$','%1')) -- gsub  2 !
end

------------------------------------------------------------------------------------------------------------------------

function playbeep(...)
	if type(arg[1])=='table' then arg = arg[1] end
    for i=1, #arg, 2 do
		plg.beep(arg[i],arg[i+1])
	end
end

------------------------------------------------------------------------------------------------------------------------

-- http://www.lua.org/pil/12.1.1.html
function serialize (o, allowdupes, pretty, useToString)
	local tmp = {}
	local tables={}
	local key
	if pretty and type(pretty) ~= 'string' then pretty = '\t' end

	local function serialize2 (o, ident)
		ident = ident or 0
		local pref = pretty and '\n'..pretty:rep(ident)
		local pref2 = pretty and pref..pretty..', '
		if type(o) == "number" then
			--table.insert(tmp, o)
			table.insert(tmp, o<=(2^53-1) and o>=-(2^53-1) and ('%0.0f'):format(o) or o)
		elseif type(o) == "boolean" then
			table.insert(tmp, o and 'true' or 'false')
		elseif type(o) == "string" then
			--table.insert(tmp,string.format("%q", o))
			table.insert(tmp, ( (string.format("%q", o)):gsub('\007','\\a'):gsub('\\\r','\\r'):gsub('\\\n','\\n') ) )
		elseif type(o) == "table" then
			if not allowdupes then
				if tables[o] then	--x={}x[x]=x
					error('Possible loop detected: '..tmp[#tmp]..tables[o])
				end
				tables[o]=key
			end
			local i1, i2 = 0, 0
			for k, v in pairs(o) do
				i1=i1+1
				if type(k)=='number' then i2=i2+1 end
			end
			local simple = (i1 == i2) and (i1 == #o)
			local zerobased = (i1 == i2) and (i1 == (#o + 1)) and o[0]
			table.insert(tmp,"{")
			--if pretty then table.insert(tmp, pref .. pretty) end
			local pref3 = pretty and pref..pretty..'  '
			if pretty then table.insert(tmp, pref3) end
			for k,v in pairs(o) do
				key=k
				if not simple then	-- key, ' = '
					if zerobased then
						if k == 0 then
							table.insert(tmp,"[0]")
							table.insert(tmp, pretty and " = " or "=" )
						end
					elseif tostring(k):find('^[%a_][%w_]*$') then
						table.insert(tmp, k)
						table.insert(tmp, pretty and " = " or "=")
					else
						serialize2(k, ident+1)
						tmp[#tmp] = '['..tmp[#tmp]..']'
						table.insert(tmp, pretty and " = " or "=" )
					end
				end
				serialize2(v, ident+1)
				table.insert(tmp, pref2 or ",")
			end
			if tmp[#tmp] == (pref2 or ",") then
				if pretty then
					tmp[#tmp] = pref
					table.insert(tmp,"}")	-- non-empty
					if tmp[#tmp-4]=='{'	-- single value
						--and tmp[#tmp-3]==pref..pretty
						and tmp[#tmp-3]==pref3
						then
						tmp[#tmp-3]=' '
						tmp[#tmp-1]=' '
					elseif tmp[#tmp-6]=='{'
						and tmp[#tmp-3] == ' = '
						--and tmp[#tmp-5]==pref..pretty
						and tmp[#tmp-5]==pref3
						then
						tmp[#tmp-5]=' '
						tmp[#tmp-1]=' '
					end
				else
					tmp[#tmp] = "}"
				end
			else
				if pretty then
					tmp[#tmp] = "}"
				else
					table.insert(tmp,"}")	-- empty
				end
			end
		else
			if useToString then
				table.insert(tmp, tostring(o) )
			else
				error("cannot serialize a " .. type(o) .. ' ('..tostring(o)..')')
			end
		end
	end

	serialize2(o)

	if pretty then table.insert(tmp, '\n') end

	return table.concat(tmp)
end


function deserialize(s)
	local f = loadstring('return ' .. s)
	setfenv(f, {})
	return pcall(f)
end


function serializeMirrors(data, skipCheck)
	if type(data) ~= 'table' then error('The argument must be a table: '..type(data) ) end
	if not (data.mirrors and next(data.mirrors)) then error('No mirrors!') end
	if usd.progstatus() == 0 then debugLog('USD stopped') return end

	local e, m = nil, getHandler(plg.tDirLink, 'ftp://m/')
	if not m then
		e = "serializeMirrors: m.lua is not found."
		usd.savetolog(e)
		return nil, e
	end
	if not skipCheck and getLstInfo().url:find('^ftp://m/') then
		e = 'serializeMirrors: Already serialized.'
		usd.savetolog(e)
		return nil, e
	end

	local shitlist = ','..table.concat(Settings['<getMirror>'] and Settings['<getMirror>'].paidshit or {},',')..','
	for k, v in pairs(data.mirrors) do
		v = trim(v)
		local host = getHost(v)
		if host and shitlist:find(','..host:gsub('([%-%+%*()%%%[%].])','%%%1')..',') then
			debugLog('Skip shit: '..v)
			data.mirrors[k] = nil
		end
	end

	local tmp = ascii85.encode(zlib.compress(serialize(data)),9):gsub("'",'v'):gsub('"','w') -- USD   
	--tmp = 'ftp://m/'..(data.name or 'noname')..(data.size and ('>'..data.size) or '')..tmp
	tmp = ('ftp://m/%s%s%s'):format(
			(data.name or 'noname'):gsub('[%s<\'"]+','_')
			, (data.size and ('>'..data.size) or ''):gsub('[%s<\'"]+','')
			, tmp )
	if #tmp > 4095 then
		e = 'Serialized data is too long!'
		usd.savetolog(e)
		return nil, e
	end

	return m, tmp
end

------------------------------------------------------------------------------------------------------------------------

-- http://lua-list.2524044.n2.nabble.com/JSON-module-td5473516.html
function n2utf8 (n)
	local char,floor = string.char, math.floor
	if n < 0x80 then
		return char (n)
	elseif n < 0x800 then
		return char (0xC0+floor (n/0x40)
			, 0x80+n%0x40)
	elseif n <= 0x10000 then
		return char (0xE0+floor (n/0x1000)
			, 0x80+floor ((n%0x1000)/0x40)
			, 0x80+n%0x40)
	elseif n <= 0x110000 then
		return char (0xF0+floor (n/0x40000)
			,0x80+floor ((n%0x40000)/0x1000)
			,0x80+floor ((n%0x1000)/0x40)
			,0x80+n%0x40)
	end
end

do
	local r = {b='\b', f='\f', n='\n', r='\r', t='\t', v='\v'}
	local e = [[escaped <- "\" ( {[uU]} {%x^4} / {[xX]} {%x^2} / {.} )]]
	function unescapeJS(str, recode)
		recode = recode or n2utf8
		return re.gsub(str,e,function(t,x)
				x = x and tonumber(x, 16)
				if x then
					return (t=='u' or t=='U') and recode(x) or string.char(x)
				end
				return r[t] or t
			end
		)
	end
end

function parseJsObject(obj, noNumKeys, noNumVals, noBoolean, newNull, zeroBase, noUnescape, flat)
	if type(obj) ~= 'string' then return end

	local function num(n)
		local r = not noNumVals and tonumber(n)
		return r and (r <= (2^53-1) and r >= -(2^53-1) ) and r or n
	end

	local pattern = re.compile([[
		jsobj		<-  emptytbl / emptyobj / obj / array
		obj			<-	( '{' ( property ( ',' property)* )? ','? %s* '}' ) 	-> tokeyval
		property	<-	pname ':' pvalue
		pname		<-	comment* %s* ( qstring / word ) %s* comment*
		pvalue		<-	comment* %s* ( jsobj / strconcat / qstring / word ) %s* comment*
		undefined	<-  '' -> null
		pvalue2		<-	pvalue / undefined
		array		<-	( '[' ( pvalue2 (%s* ',' pvalue2 )* )? %s* ']' / '{' ( pvalue (%s* ',' pvalue )* )? %s* '}')	-> toarr
		emptytbl	<-	( '[' comment? ']' ) 										-> {}
		emptyobj	<-	( '{' comment? '}' ) 										-> {}
		strconcat	<-	{ qstring %s* "+" %s* qstring (%s* "+" %s* qstring)*} 		-> concat
		qstring		<-	( "'" { ( "\" . / [^\'] )* } "'"  /  '"' {  ( '\' . / [^\"] )* } '"' )
		word		<-	{[_.%w-]+}
		comment		<-	%s* ("//" [^%nl]* / "/*" (!'*/' .)* "*/" ) %s*
	]], {
		tokeyval = function(...)	--   key=value   
				local args = {...}
				if flat then return #args, ... end
				local t = {}
				for i=1, #args, 2 do
					--local k = not noNumKeys and tonumber(args[i]) or args[i]
					--local v = not noNumVals and tonumber(args[i+1]) and tonumber(args[i+1])<math.huge and tonumber(args[i+1]) or args[i+1]
					local k = num(args[i])
					local v = num(args[i+1])
					if not noBoolean and v == 'true' then v = true end
					if not noBoolean and v == 'false' then v = false end
					if type(k) == 'string' and not noUnescape then k = unescapeJS(k) end
					if type(v) == 'string' and not noUnescape then v = unescapeJS(v) end
					if v == 'null' then v = newNull end
					t[k] = v
				end
				return t
			end
        , toarr = function(...)
				local args = {...}
				if flat then return #args, ... end
				local t = {}
				for i=1, #args do
					local k = zeroBase and i-1 or i
					local v = num(args[i])
					if type(v) == 'string' and not noUnescape then v = unescapeJS(v) end
					if not noBoolean and v == 'true' then v = true end
					if not noBoolean and v == 'false' then v = false end
					if v == 'null' then v = newNull end
					t[k] = v
				end
				return t
        	end
		, concat = function(_, ...)	return table.concat({...},'') end
        , null = function() return nil end
	})

--debugSave('parseJsObject_'..pad(counters.parsejsobject,2)..'.js',obj)
	local b,e=re.find(obj, pattern)
	if not b then return end
	obj = string.sub(obj, b, e) --0.12
--debugSave('parseJsObject_'..pad(counters.parsejsobject,2)..'.js',obj)

	if flat then
		--return { re.find(obj, pattern) }
		return { re.match(obj, pattern) }
	end

	--local tmp1, tmp2 = re.find(obj, pattern)
	--return tmp2
	return re.match(obj, pattern)
end

------------------------------------------------------------------------------------------------------------------------

function setHeader(hdr, clean)
	if type(hdr)=='table' then for _, v in ipairs(hdr) do setHeader(v, clean) end return end
	local hdr2 = hdr:gsub ('([%-%+%*()%%%[%].])','%%%1'):gsub('\\','\\\\')
	local c = usd.getcookie()
	c=c:gsub('^'..hdr2..';? ?', ''):gsub(';? ?\r\n'..hdr2..';? ?', '; '):gsub('^[; ]*(.-)[; ]*$','%1')
	if not clean then c = c .. '\r\n'..hdr end
	usd.setcookie(c)
end

function setXHR(clean)
	setHeader('X-Requested-With: XMLHttpRequest', clean)
end

------------------------------------------------------------------------------------------------------------------------

function getLstInfo(useCache)
	if useCache and tmpData.getLstInfoCache then
		debugLog('getLstInfo: cached: ' .. serialize(tmpData.getLstInfoCache))
		return tableCopy(tmpData.getLstInfoCache)
	end
	usd.addquery('http://_create_lst_')	--  USD  .lst; origUrl   - getMirror()
	local lst = usd.workdir .. plg.exename .. '.lst'
	usd.waittime(Settings['<misc>'].getLstInfoPause)

	local item = fileRead(lst)
	if not item then
		usd.savetolog("getLstInfo: Can't open ".. lst)
		return nil
	end
	--  
	item = (item or ''):match('.-\r\n(item0=.+)')
	item = (item or ''):match('^(.-)\r\nitem1=') or item

	if not item then
		usd.savetolog("getLstInfo: Can't read ".. lst)
		return nil
	end

	local t = {}
	for k, v in item:gmatch('item0_?([^=]*)=([^\r\n]*)') do
		k = (k=='' and 'url' or k):lower()
		t[k] = v~='' and v
	end

	debugLog('getLstInfo: ' .. serialize(t))
	tmpData.getLstInfoCache = tableCopy(t)

    return t
end

local setPusdNameOCOE=function()debugLog('setPusdNameOCOE')usd.setretresult(1,5)end
regCheckError('http://0.0.0.0/setPusdName/',setPusdNameOCOE,setPusdNameOCOE)

function setPusdName(name)
	if Settings['<misc>'].extDownloader then return false end
	local info = getLstInfo()
	if not info.size then
		usd.savetolog('setPusdName: getLstInfoPause is too small?')
		info = getLstInfo()  --  
		if not info.size then
			usd.savetolog('setPusdName: getLstInfo() error!')
			return
		end
	end
	if info.localfile then return false, info end
	name = filterName(name)
	debugLog('setPusdName: name = '..name)
	usd.setretresult('http://0.0.0.0/setPusdName/'..name,0,0)
	return true, info
end

function getResumeFlag(lstInfo)
	local fname = (lstInfo or getLstInfo()).localfile
	if not fname then return 0 end
	fname = fname and fname .. '.pusd'
	local pusdSize = fileSize(fname) or 0
	local limit = Settings['<misc>'].getResumeFlagLimit
	local resume = pusdSize < limit and 0 or 1
	debugLog( ('getResumeFlag: pusdSize = %d %s limit = %d; resume flag = %d'):format(
		pusdSize, pusdSize<limit and '<' or '>=', limit, resume) )
	return resume
end


------------------------------------------------------------------------------------------------------------------------

--http://stackoverflow.com/questions/183485/can-anyone-recommend-a-good-free-javascript-for-punycode-to-unicode-conversion
Punycode = {
	 initial_n = 0x80
	,initial_bias = 72
	,delimiter = "-"
	,base = 36
	,damp = 700
	,tmin = 1
	,tmax = 26
	,skew = 38
	,maxint = 0x7FFFFFFF
}

Punycode.utf16={
	decode = function(input, codePage)
		local output = {}
		input = plg.recode(codePage or CP_UTF8, CP_WINUNICODE, input)
		input = plg.lowerW(input)
		local len = #input
		local value, extra
		for i=1, len, 2 do
			value = input:byte(i)+input:byte(i+1)*256
			--value = Punycode.ansiToUnicode[value] or value
			table.insert(output, value)
		end
		return output
	end
}

Punycode.decode_digit = function (cp)
	return cp - 48 < 10 and cp - 22 or cp - 65 < 26 and cp - 65 or cp - 97 < 26 and cp - 97 or Punycode.base;
end

Punycode.encode_digit = function (d, flag)
	return d + 22 + 75 * (d < 26 and 1 or 0) - ((flag ~= 0 and 1 or 0) * 2^5);
end

Punycode.adapt = function (delta, numpoints, firsttime)
	local k
	delta = firsttime and math.floor(delta / Punycode.damp) or math.floor(delta / 2);
	delta = delta + math.floor(delta / numpoints);
	k = 0
	while delta > math.floor(((Punycode.base - Punycode.tmin) * Punycode.tmax) / 2) do
		delta = math.floor(delta / (base - tmin))
		k = k + base
	end
	return k + math.floor(((Punycode.base - Punycode.tmin + 1) * delta) / (delta + Punycode.skew))
end

Punycode.encode_basic = function (bcp, flag)
	bcp = (bcp - 97 < 26 and 1 or 0) * 2^5
	return bcp + ((not flag and (bcp - 65 < 26 and 1 or 0)) * 2^5 );
end

Punycode.encode = function (input, codePage)
	local n, delta, h, b, bias, j, m, q, k, t, ijv, case_flags;
	--input = Punycode.utf16.decode(input:lower());
	input = Punycode.utf16.decode(input, codePage);
	local input_length = #input
	local output={}
	n = Punycode.initial_n;
	delta = 0;
	bias = Punycode.initial_bias;
	--// Handle the basic code points:
	for j = 1, input_length do
		if input[j] < 0x80 then
			--table.insert(output, string.char(Punycode.ansiToUnicode[input[j]] or input[j]) )
			table.insert(output, string.char(input[j]) )
		end
	end

	h = #output
	b = #output
	--// h is the number of code points that have been handled, b is the
	--// number of basic code points

	if (b > 0) then table.insert(output, Punycode.delimiter) end

	--// Main encoding loop:
	while (h < input_length) do
	--    // All non-basic code points < n have been
	--    // handled already. Find the next larger one:
		m = Punycode.maxint
		for j=1, input_length do
			ijv = input[j];
			if (ijv >= n and ijv < m) then m = ijv end
		end

		if (m - n > math.floor((Punycode.maxint - delta) / (h + 1))) then
			error("punycode_overflow (1)")
		end
		delta = delta + (m - n) * (h + 1);
		n = m

		for j = 1, input_length do
			ijv = input[j];
			if ijv < n then
				delta = delta+1
				if (delta > Punycode.maxint) then error("punycode_overflow (2)") end
			end

			if (ijv == n) then
				q = delta
				k = Punycode.base
				while true do
					t = k <= bias and Punycode.tmin or k >= bias + Punycode.tmax and Punycode.tmax or k - bias;
					if (q < t) then break end
					table.insert(output, string.char( Punycode.encode_digit(t + (q - t) % (Punycode.base - t), 0)) );
					q = math.floor( (q - t) / (Punycode.base - t) );
					k = k + Punycode.base
				end
				table.insert(output, string.char( Punycode.encode_digit(q, 0 )));
				bias = Punycode.adapt(delta, h + 1, h == b);
				delta = 0;
				h = h + 1
			end
		end

		delta = delta+1
		n = n+1;
	end
	return table.concat(output, '')
end

Punycode.toAscii = function ( domain, codePage )
    local domain_array = {}
    for d in domain:gmatch('[^.]+') do table.insert(domain_array, d) end
    out = {}
    for i=1, #domain_array do
    	local s = domain_array[i]
    	table.insert(out, s:find('[^A-Za-z0-9-]') and "xn--" .. Punycode.encode(s, codePage) or s:lower())
    end
    return table.concat(out, '.')
end

------------------------------------------------------------------------------------------------------------------------

-- scheme userinfo host port path query fragment

-- http://tools.ietf.org/html/rfc3986#appendix-A
-- http://www.cyberforum.ru/javascript/thread342063.html
URI = {}
URI.__oldURI = URI

URI.__index = function(t,k)
	if k == 'path' then
		--return t.path_abempty or t.path_absolute or t.path_noscheme or t.path_rootless or '/'
		return rawget(t, 'path_abempty') or rawget(t, 'path_absolute') or rawget(t, 'path_noscheme') or rawget(t, path_rootless)
	else
		return rawget(t, k) or rawget(URI.__oldURI, k)
	end
end

URI.__newindex = function(t,k,v)
	if t == URI.__oldURI then error("Table 'URI' is write-protected!",2) end
	if k == 'path' then
		local oldAbs = t.path_abempty or t.path_absolute
		local oldRel = t.path_noscheme or t.path_rootless
		t.path_abempty, t.path_absolute, t.path_noscheme, t.path_rootless = nil
		if v:find('^/') then
			rawset(t, 'path_absolute', URI.simplify(v) )
		elseif oldRel then
			rawset(t, 'path_rootless', URI.simplify(v) )
		else
			rawset(t, 'path_absolute', URI.simplify((oldAbs or '/'):gsub('/[^/]+$','/') .. v) )
		end
	else
		rawset(t, k, v)
	end
end

URI.pattern = re.compile([[

	URI_reference	<- URI / relative_ref

	URI				<- scheme ":" hier_part ( "?" query )? ( "#" fragment )?

	hier_part		<- '//' authority path_abempty
					/  path_absolute
					/  path_rootless
					/  path_empty

	absolute_URI	<- scheme ":" hier_part ( "?" query )?

	relative_ref	<- relative_part ( "?" query )? ( "#" fragment )?

	relative_part	<- "//" authority path_abempty
					/  path_absolute
					/  path_noscheme
					/  path_empty

	scheme			<- ( {:name: '' -> 'scheme' :}   {( ALPHA ( ALPHA / DIGIT / "+" / "-" / "." )* )} )		-> {}

	authority		<- (( userinfo "@" )? host ( ":" port )?)
	userinfo		<- ( {:name: '' -> 'userinfo' :} {( unreserved / pct_encoded / sub_delims / ":" )*} )	-> {}
	host			<- ( {:name: '' -> 'host' :}     {(IP_literal / IPv4address / reg_name)} )				-> {}
	port			<- ( {:name: '' -> 'port' :}     {DIGIT*} )												-> {}

	IP_literal		<- "[" ( IPv6address / IPvFuture  ) "]"

	IPvFuture		<- [vV] HEXDIG+ "." ( unreserved / sub_delims / ":" )+
    IPv6address		<-                             ( h16 ":" )^6 ls32
					/                         "::" ( h16 ":" )^5 ls32
					/ ( h16                )? "::" ( h16 ":" )^4 ls32
					/ ( h16 ( ":" h16 )?   )? "::" ( h16 ":" )^3 ls32
					/ ( h16 ( ":" h16 )^-2 )? "::" ( h16 ":" )^2 ls32
					/ ( h16 ( ":" h16 )^-3 )? "::"   h16 ":"     ls32
					/ ( h16 ( ":" h16 )^-4 )? "::"               ls32
					/ ( h16 ( ":" h16 )^-5 )? "::"   h16
					/ ( h16 ( ":" h16 )^-6 )? "::"


	ls32			<- ( h16 ":" h16 ) / IPv4address
	h16				<- HEXDIG HEXDIG^-3
	IPv4address		<- dec_octet "." dec_octet "." dec_octet "." dec_octet
	dec_octet		<- DIGIT			-- 0-9
					/  [1-9] DIGIT		-- 10-99
					/  "1" DIGIT^2		-- 100-199
					/  "2" [0-4] DIGIT	-- 200-249
					/  "25" [0-5]		-- 250-255

	reg_name		<- ( unreserved / pct_encoded / sub_delims )*

	path			<- path_abempty
					/  path_absolute
					/  path_noscheme
					/  path_rootless
					/  path_empty

	path_abempty	<- ( {:name: '' -> 'path_abempty' :}  { ( "/" segment )* } )						-> {}
	path_absolute 	<- ( {:name: '' -> 'path_absolute' :} { "/" ( segment_nz ( "/" segment )* )? } )	-> {}
	path_noscheme	<- ( {:name: '' -> 'path_noscheme' :} { segment_nz_nc ( "/" segment )* } )			-> {}
	path_rootless	<- ( {:name: '' -> 'path_rootless' :} { segment_nz ( "/" segment )* } )				-> {}
	path_empty		<- ( {:name: '' -> 'path_empty' :}    {''} )										-> {}

	segment			<- pchar*
	segment_nz		<- pchar+
	segment_nz_nc	<- ( unreserved / pct_encoded / sub_delims / "@" )+

	pchar			<- unreserved / pct_encoded / sub_delims / ":" / "@"

	query			<- ( {:name: '' -> 'query' :}    {( pchar / "/" / "?" )*} )	-> {}

	fragment		<- ( {:name: '' -> 'fragment' :} {( pchar / "/" / "?" / "|" / " " )*} )	-> {}

	pct_encoded		<- "%" HEXDIG HEXDIG

	unreserved		<- ALPHA / DIGIT / "-" / "." / "_" / "~" / UTF8 / CYRILLIC / OTHER_SYMBOLS
	reserved		<- gen_delims / sub_delims
	gen_delims		<- ":" / "/" / "?" / "#" / "[" / "]" / "@"
	sub_delims		<- "!" / "$" / "&" / "'" / "(" / ")" / "*" / "+" / "," / ";" / "="

	ALPHA			<- [A-Za-z]
	DIGIT			<- [0-9]
	HEXDIG			<- [0-9A-Fa-f]

	OTHER_SYMBOLS	<- "[" / "]"

	CYRILLIC		<- [--]

	UTF8tail		<- ]]..'[\128-\191]\r\n'..[[
	UTF8	<- ]]
	--.. '[\000-\127] / [\194-\223][\128-\191] / [\224][\160-\191][\128-\191] / [\225-\236\238\239][\128-\191][\128-\191]'
	.. ' [\194-\223] UTF8tail'
	.. ' / [\224][\160-\191] UTF8tail / [\225-\236\238\239] UTF8tail UTF8tail / [\237][\128-\159] UTF8tail'
	.. ' / [\240][\144-\191] UTF8tail UTF8tail / [\241-\243] UTF8tail UTF8tail UTF8tail / [\244][\128-\143] UTF8tail UTF8tail'
)
--227 129 187

--http://www.faqs.org/rfcs/rfc3629.html
--http://keithdevens.com/weblog/archive/2004/Jun/29/UTF-8.regex

--   build    userinfo  fragment;    'http',   - '/'.
function URI:__tostring(build)
	if self.__oldURI ~= URI.__oldURI then error('Wrong object: '..tostring(self)..' ('..type(self)..')') end
	local u = {}
	local function add(a,b,c) if a then table.insert(u, b or ''); table.insert(u, c or ''); end end
	--add (self.scheme,	self.scheme, ':')
	add (true,	self.scheme or 'http', ':')
	table.insert(u, '//')
	add (self.userinfo and build, self.userinfo, '@')
	add (self.host,	self.host)
	add (self.port, ':', self.port)
	if self.path_abempty and not self.host then
		add (true, 	'//', self.path_abempty)
	else
		table.insert(u, self.path_abempty or self.path_absolute or self.path_noscheme or self.path_rootless or '/')
	end
	add (self.query, 	'?', self.query)
	add (self.fragment and build, '#', self.fragment)

	return table.concat(u)
end

function URI:__call(rel, build)
	if rel then
		return self:combine(rel, build) -- build = codePage
	--elseif build
	else
		return self:__tostring(build)
	end
end

function URI.simplify(path)
	local n
	repeat
		path, n = path:gsub('/%./','/')			-- '/./' -> '/'
	until n==0
	repeat
		path, n = path:gsub('/[^/]*/%.%./','/')	-- '/somedir/../' -> '/'
	until n==0
	path = path:gsub('/%.$','/'):gsub('/[^/]*/%.%.$','/'):gsub('//+','/')
	return path
end

function URI.parse(base, codePage)
	if type(base)~='string' then error('"base" must be a string: '..tostring(base)..' ('..type(base)..')', 2) end

	local parse = function(url)
		local tmp = {re.match(base, URI.pattern)}
		local tmp2 = {}
		setmetatable(tmp2, URI.__oldURI)
		for i=1, #tmp do		--  {[1]='value',name='test'}
			local n = tmp[i].name
			local v = tmp[i][1]
			if n=='scheme' then v = string.lower(v) end
			--if n=='host' then v = Punycode.toAscii(string.lower(v)) end
			if n=='host' then v = Punycode.toAscii(unescape(v), codePage) end
			if n:find('^path_') then
				v = URI.simplify(v)
				if v:find('[\128-\255]') then
					v = v:gsub('[\128-\255]+', function(c)
						return escapeU(codePage and plg.recode(codePage, CP_UTF8, c) or c)
					end)
				end
			end
			if v~='' then tmp2[n] = v end
		end
		-- ? if not tmp2.port and scheme=='https' then tmp2.port = 443 end
		return tmp2
	end
	return parse(base)
end

function URI.combine(base, relative, codePage)
	if type(base) == 'string' then
		base = URI.parse(base, codePage)
	elseif not (type(base) == 'table' and base.__oldURI == URI.__oldURI) then
		error('"base" must be a string or URI object: '..tostring(base)..' ('..type(base)..')', 2)
	end

	if relative and type(relative) == 'string' then
		relative = URI.parse(relative, codePage)
	elseif not (type(relative) == 'table' and relative.__oldURI == URI.__oldURI) then
		error('"relative" must be a string or URI object: '..tostring(relative)..' ('..type(relative)..')',2)
	end

	local rPath = relative.path_abempty or relative.path_absolute or relative.path_noscheme or relative.path_rootless
	local rNonEmpty = next(relative)
	local tmp2 = {
		  scheme       = relative.scheme or base.scheme
        , userinfo     = relative.userinfo
        , host         = relative.host or (not relative.scheme and base.host) or nil
        , port         = relative.port or (not (relative.host or relative.scheme) and base.port) or nil
        , path_abempty = relative.path_abempty or relative.path_absolute or (not (rPath or relative.host) and base.path_abempty) or nil
        , query        = relative.query or (not (rPath or relative.host) and base.query) or nil
        , fragment     = relative.fragment or (not rNonEmpty and base.fragment) or nil
	}

	if rPath and not tmp2.path_abempty then
		if not relative.scheme then
			tmp2.path_abempty = (base.path_abempty or '/'):gsub('/[^/]+$','/') .. rPath
		else
			tmp2.path_noscheme = relative.path_noscheme
			tmp2.path_rootless = relative.path_rootless
		end
	end

	if tmp2.path_abempty then tmp2.path_abempty = URI.simplify(tmp2.path_abempty) end

	setmetatable(tmp2, URI.__oldURI)
	return tmp2
end

function URI.recode(url, codePage)
	if url:find('^ftp://m/') then return url end
	local tmp = URI.parse((url:gsub('\032','%%20')), codePage)
	tmp = tmp(nil, true)				-- userinfo, fragment
	if url ~= tmp then
		debugLog('URI.recode: old: '..url)
		debugLog('URI.recode: new: '..tmp)
		return tmp
	end
	return url
end

------------------------------------------------------------------------------------------------------------------------

do
	local getHost_d2 = tableKeys('1fichier.com', 'letitbit.net', 'megashares.com', 'shareflare.net', 'vip-file.com')
	--local getHost_d2 = {}
	function getHost(url, isHost, codePage, level)
		--if Settings and not next(getHost_d2) then getHost_d2 = tableKeys(unpack(Settings['<misc>'].getHostL2 or {})) end
		if type(url) == 'string' then
			if not isHost then
				url = URI.parse(url, codePage)
			end
		elseif not (type(url) == 'table' and url.__oldURI == URI.__oldURI) then
			error('"url" must be a string or URI object: '..tostring(url)..' ('..type(url)..')', 2)
		end
		local h = isHost and Punycode.toAscii(unescape(url), codePage) or url.host
		if h and not level then
			h = h:gsub('^ww*%d*%.([%w-]+%..-)','%1')
			h = h:gsub('^[%w.]-%.([^.]+%.[^.]+)$', getHost_d2)
		end
		if h and level then
			local ip = {h:match('^(%d+)%.(%d+)%.(%d+)%.(%d+)$')}
			if #ip>0 then	for i=1, 4 do	if #ip[i]>3 or tonumber(ip[i])>255 then	ip = nil	break	end	end	end
			if #ip>0 then return level=='#' and 1 or h end
			local tmp = split(h, '.')
			if level=='#' then return #tmp end
			level = minMax(1,#tmp, level)
			h = table.concat(tmp, '.', #tmp-level+1)
		end
		return h
	end
end

------------------------------------------------------------------------------------------------------------------------

function replaceVars(str)
	return (str:gsub('%%(%w+)%%',os.getenv))
end

------------------------------------------------------------------------------------------------------------------------

do	-- http://www.inf.puc-rio.br/~roberto/lpeg/
	-- Lexical Elements
	local Space = lpeg.S(" \r\n\t")^0
	local Number = lpeg.C(lpeg.P"-"^-1 * lpeg.R("09")^1) * Space
	local TermOp = lpeg.C(lpeg.S("+-")) * Space
	local FactorOp = lpeg.C(lpeg.S("*/")) * Space
	local Open = "(" * Space
	local Close = ")" * Space

	-- Grammar
	local Exp, Term, Factor = lpeg.V"Exp", lpeg.V"Term", lpeg.V"Factor"
	local G = lpeg.P{ Exp,
	  Exp = lpeg.Ct(Term * (TermOp * Term)^0);
	  Term = lpeg.Ct(Factor * (FactorOp * Factor)^0);
	  Factor = Number + Open * Exp * Close;
	}

	G = Space * G * -1

	-- Evaluator
	local function eval (x)
	  if type(x) == "string" then
	    return tonumber(x)
	  else
	    local op1 = eval(x[1])
	    for i = 2, #x, 2 do
	      local op = x[i]
	      local op2 = eval(x[i + 1])
	      if (op == "+") then op1 = op1 + op2
	      elseif (op == "-") then op1 = op1 - op2
	      elseif (op == "*") then op1 = op1 * op2
	      elseif (op == "/") then op1 = op1 / op2
	      end
	    end
	    return op1
	  end
	end

	-- Parser/Evaluator
	function evalExp (s)
	  local t = lpeg.match(G, s)
	  if not t then error("syntax error", 2) end
	  return eval(t)
	end

	-- small example
	--print(evalExp"3 + 5*9 / (1+1) - 12")   --> 13.5
end


function shitFlare(url, data)
	data = data or {}
	local conf = Settings['<shitFlare>'] or {}
	local host = getHost(data.location or url or usd.getlocation())
	Storage['shitFlare'] = not conf.delCookies and Storage['shitFlare'] or {}
	local st = Storage['shitFlare']
	local cookies = splitKV(usd.getcookie(),'=',';')
	cookies.cf_clearance =
		cookies.cf_clearance
		or not data.noSaveCookies and st[host]
		or nil
	usd.setcookie(tableConcat(cookies,'=', '; '))
	if data.getCookie then return end

	local function getDonorCookie()
		if not conf.cookieDonors or #conf.cookieDonors==0 then return end
		local donor = conf.cookieDonors[math.random(#conf.cookieDonors)]
		local cookies = splitKV(usd.getcookie(),'=',';')
		usd.setcookie('')
		usd.setreferer(donor)
		debugSaveInc('shitFlare.html', shitFlare(donor,{noDonors=true, location=donor}))
		cookies.cf_clearance = usd.getcookie():match('cf_clearance=([%x-]+)')
		usd.setcookie(tableConcat(cookies,'=', '; '))
	end
	if data.getDonorCookie then return getDonorCookie() end

	local page, timeout, form
	page = usd.get(url)

	local shit = page:match('<form[^>]-action="/cdn%-cgi/l/chk_captcha".-</form>')
		or page:match('<form[^>]-action="/cdn%-cgi/l/chk_jschl".-</form>')
		or page:match('<form id="ChallengeForm".-name="jschl_answer".-</form>')
	if shit then
		debugSaveInc('shitFlare.html', page)
		data.location = data.location or usd.getlocation()
		form = Form.parse(shit)
		form.action = URI.combine(data.location, form.action)()
		--if shit:find('cgi/l/chk_jschl') then
		if form.inputs.jschl_answer then
			local a, timeout = page:match("getElementById%('jschl%-answer'%).-%.value%s*=%s([%d/*+-]+);.-submit%(%);%s*},%s*(%d+)%);")
			a = a or page:match("$%('#jschl_answer'%).val%((.-)%);")
			timeout = math.floor(tonumber(timeout)/1000+.5)
			form.inputs.jschl_answer = evalExp(a) + (timeout and #URI.parse(data.location).host or 0)
			usd.waittime(timeout or 6)
		else
			if not data.noDonors then
				getDonorCookie()
				usd.setreferer('')
				local tmp = usd.getcookie()
				local page = usd.get(url)
				if not page:find('"/cdn%-cgi/l/chk_captcha"') then
					st[host] = not (conf.delCookies or data.noSaveCookies) and usd.getcookie():match('cf_clearance=([%x-]+)') or nil
					return page
				end
				usd.getcookie(tmp)
				usd.setreferer(data.location)
			end
			data.key = data.key or shit:match('%?k=([^"]+)') or '6LeT6gcAAAAAAAZ_yDmTMqPH57dJQZdQcu6VFqog'
			form.inputs.recaptcha_response_field, timeout, form.inputs.recaptcha_challenge_field
				= queryReCaptcha(data.key, 0, nil, getHost(data.location), nil, true) -- gooCheck
		end
		page = form:submit()
	end

	st[host] = not (conf.delCookies or data.noSaveCookies) and usd.getcookie():match('cf_clearance=([%x-]+)') or st[host] or nil
	return page
end



function urlHead(starturl, referer, tries)
	if usd.progstatus() == 0 then return end
	referer = referer or usd.getlocation()
	tries = tries or 20
	usd.relocationmode(0)
	usd.setreferer(referer)
	local url = starturl:gsub('^https:','http:')
	local hdrs = {}
	local tmp = usd.head(url)
	table.insert(hdrs, tmp)
	if tmp:find('[\r\n][Ll][Oo][Cc][Aa][Tt][Ii][Oo][Nn]: ') then
		for i = 2, tries do
			url = tmp:match('[\r\n][Ll][Oo][Cc][Aa][Tt][Ii][Oo][Nn]: ([^\r\n]+)')
			usd.setreferer(referer)
			if not url then break end
			url = URI.combine(usd.getlocation(),url)
			if url.scheme=='https' then url.scheme='http' end
			url = url()
			tmp = usd.head(url)
			table.insert(hdrs, usd.getheaders())
		end
	end
	usd.relocationmode(1)
	return ('urlHead %d/%d tries; %s\r\n\r\n%s'):format(#hdrs, tries, starturl, tableConcat(hdrs,'\r\n','\r\n'..('-'):rep(88)..'\r\n') )
end



function urlGet(url, data)
	if usd.progstatus() == 0 then return end
	data = tableCombine({referer = usd.getlocation(), tries = 20, headCheck=nil }, data or {})
	debugLog('urlGet data: '..serialize(data))
	if data.headCheck and url:find(data.headCheck) then return url end
	usd.relocationmode(0)
	usd.setreferer(data.referer)
	local uri = URI.parse(url)
	local tmp
	local post = data.post
	for i = 1, data.tries do
		if not data.https then uri.scheme='http' end
		url = uri()
		if usd.progstatus() == 0 then return debugLog('USD stopped') end
		if data.headers then setHeader(data.headers) end
		tmp = post and usd.post(url,post) or usd.get(url)
		if data.headers then setHeader(data.headers, true) end
		local h = usd.getheaders()
		local code = h:lower():match('%shttp/%d%.%d (%d+)')
		if code=='302' or code=='303' then post=nil end		-- rfc2616 10.3.3 302
		url = h:match('[\r\n][Ll][Oo][Cc][Aa][Tt][Ii][Oo][Nn]: ([^\r\n]+)')
		usd.setreferer(data.referer)
		if not url then break end
		if not data.noLog then debugSaveInc('urlGet.html', tmp, 'try '..i) end
		if data.headCheck and url:find(data.headCheck) then
			debugLog('headCheck ok')
			usd.relocationmode(1)
			return url
		end
		uri = uri(url)
		if data.wait then usd.waittime(data.wait) end
	end
	usd.relocationmode(1)
	return not data.headCheck and tmp
end

function minMax(min,max,value) return math.min(math.max(min,value),max) end

------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------

(function(...)
	local function readonly(tname)
		local proxy = {} -- http://www.lua.org/pil/13.4.5.html
		local old = _G[tname]
		local mt = {
			__index = function(t,k) return old[k] end
			, __newindex = function(t,k,v) error("Table '"..tname.."' is write-protected!",2) end
		}
		setmetatable(proxy, mt)
		_G[tname] = proxy
	end

	local wp = {}
	for k, v in pairs(_G) do
		if k~='_G' and type(v) == 'table' then
			table.insert(wp, k)
			readonly(k)
		end
	end
	debugLog('    Write protected: '..table.concat(wp, ', '))
end)();


------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------
Storage = {}


_exec = function(fname)
	local func, err = loadfile(replaceVars(fname))
	if func then
		usd.savetolog('    loading ' .. fname)
		func()
	elseif err:find(': No such file or directory$') then	-- cannot open d:\file.lua: No such file or directory
		usd.savetolog('    not loaded (OK): ' .. err)
	else
		usd.savetolog('    not loaded (error): ' .. err)
		plg.msg('Error:\n\n'..err)
	end
end
_exec2 = function(name) _exec(usd.workdir .. 'lua\\' .. name) end

Captchas = {}
captchaAttempts = 3
_exec2 'captchas.lua'

Accounts={}
function addAccount(site, login, pass)
	Accounts[site]=Accounts[site] or {}
	table.insert(Accounts[site], {login=login, password=pass} )
end
_exec2 (plg.plgname .. '_accounts.lua')

Settings={}
_exec2 (plg.plgname .. '_settings.lua')
_exec2 (plg.plgname .. '_settings2.lua')
Settings['<misc>'] = tableCombine({getResumeFlagLimit=128*1024}, Settings['<misc>'] or {} )
local sm = Settings['<misc>']
sm.modqueryPause = math.max(sm.modqueryPause or 0, 4)	  --  4 
sm.getLstInfoPause = math.max(sm.getLstInfoPause or 0, 3) --  3 
sm.extDownloader = tonumber( usd.ini.main.dowithlink ) ~= 0
sm.tempDir = sm.tempDir and replaceVars(sm.tempDir):gsub('\\$','')..'\\'
if type(sm.extIPservices)=='table' then sm.extIP = sm.extIPservices[math.random(#sm.extIPservices)] end
--sm.getHostL2 = sm.getHostL2 or {'1fichier.com', 'letitbit.net', 'megashares.com', 'shareflare.net', 'vip-file.com'}
_exec2('somelibrary.luac')

_exec, _exec2, sm = nil
