
--     
function GDL(origUrl) -- GetDirectLink
    local logpref = script.name .. '_GDL_v08'
    --    ; script.name -    

--[[
usdLua_settings.lua:

Settings['dailymotion_com'] = { interactive = false, qualityList = {'hd1080', 'hd720', 'hq', 'sd', 'ld'} }

interactive -   

]]

    local ql = {'hd1080', 'hd720', 'hq', 'sd', 'ld'}
	local qf = {ld='ld_',sd='',hq='hq_',hd720='hd_',hd1080='hd1080_'}
	local conf = Settings[script.name]
		or { qualityList = ql }
	--   usdLua_settings.lua  

    usd.setstatus(script.name)

    local dirUrl

	local resume = 0

	--   
	local fmt = string.match(origUrl, '#fmt=(%w+)')
	if fmt then
		resume = 1
		origUrl = origUrl:match('^([^#]+)')
	end

	script.tmp={}

	usd.setcookie('family_filter=off; lang=en_US', 1)	--     

	local id = origUrl:match('/video/(%w+)')

	local page = usd.get('http://www.dailymotion.com/embed/video/'..id)
	debugSaveInc(logpref..'.html', page)

	--     "HTTP/1.1 410 Gone",   .
	if string.find(usd.getheaders(), 'HTTP/%d%.%d 410 Gone') then
		usd.setretresult('%deleted%')
		return
	end

	local data = parseJsObject(page:match('var info = ({.+)'))
	debugSaveInc(logpref..'.html', serialize(data,nil,true), nil, false)

	if data.error then
		if data.error.title == 'Content rejected.' then
			usd.setretresult('%deleted%')
		else
			usd.setretresult('%'..data.error.message)
		end
		return
	end

	local duration = math.floor(data.duration / 60).. ':' .. pad(data.duration % 60, 2)

	local title = utf8ToAnsi(entityDecode(data.title))

	local info = {}


	local urls = {} --       
	for _, v in ipairs(ql) do
		local stream = data['stream_h264_'..(qf[v])..'url']
		if stream then
			local tmp = stream:match('/cdn/([^/]+)/video/')
			local codec, res = tmp:match('^(.-)%-([%dx]+)$')
			debugSaveInc(logpref..'.html', usd.head(stream), ('%s\r\n%s'):format(origUrl, v) )
			urls[v] = usd.getlocation()
			local size = usd.getheaders():match('HTTP/%d%.%d 200 OK') and usd.getheaders():match('Content%-Length: (%d+)')
			size = size and string.format('%0.2f', size / 1024 / 1024) or ' ??????'

			table.insert(
				info, string.format(
					'%s MB:  ~%s %s  %s'
					, pad(size, 7, '  ')
					, pad(res, 9, '  ')
					, pad(codec, 4, '  ')
					, v
				)
			)
		end
	end

	if fmt and urls[fmt] then
		dirUrl = urls[fmt]
		dirUrl = addNewName(dirUrl, title)
		usd.setretresult( dirUrl, 0, resume )
		return
	end

	if #info == 0 then
		local vsrc = page:match('<link rel="video_src" href="(.-)"'):gsub('&amp;','&')
		debugLog('video_src = '..vsrc)
		if vsrc and not vsrc:find('dailymotion.com/') then
			local h
			h = getHandler(plg.tDirLink, vsrc)
			if not h then
				usd.setretresult('%Unknown hosting: '..vsrc)
				return
			end
			script.tmp.vsrc = vsrc
			h(vsrc)
			return
		end
	end

	if conf.interactive then
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		local dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match(' (%w+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		dirUrl = urls[q]
		dirUrl = addNewName(dirUrl, title)
		usd.setretresult( dirUrl, 0, resume )
		return
	end


	--      qualityList    video . 
	for k, fmt in ipairs(conf.qualityList) do
		if urls[fmt] then
			dirUrl = urls[fmt]
			break
		end
	end

	if not dirUrl then
		fmt, dirUrl = next(urls)	--   
	end

	usd.modquery(origUrl .. '#fmt='..fmt)


	-- USD  ,      , 
	--  dailymotion   /    .
	--usd.relocationmode(0);				--  
	--usd.post(rUrl, '%simple%')			--   
	--local dirUrl = string.match(usd.getheaders(), 'Location: ([^%s]+)', 2)
	--        
	--     ,      
	return usd.setretresult(dirUrl, 0, resume) -- url, wait 0, 1=resume
end

--   
function OS(origUrl, dirUrl, fullName) -- OnSuccess
	logpref = script.name .. '_OS'

	if script.tmp.vsrc then
		local OShandler = getHandler(plg.tOnSuccess, script.tmp.vsrc)
		if OShandler then OShandler(script.tmp.vsrc, dirUrl, fullName) end
		return
	end

	--local page = usd.get(origUrl)
	--debugSaveInc('dailymotion_com_OS.html', page)
	--local title = string.match(page, '<span class="title" title="([^"]+)">')
	----     
	--title = utf8ToAnsi(title)	--    UTF-8  ANSI
	local tmp = fileRename(fullName, title, '.mp4') --  
	return usd.setretresult(tmp) --  USD  
end

--   GetDirectLink  OnSuccess  'dailymotion.com/video/'
--regDirSuccess('dailymotion.com/video/', GDL, OS)
regDirSuccess('dailymotion.com/', GDL, OS)
regDirSuccess('//dai.ly/', GDL, OS)

-- dailymotion.com/embed/video/
-- http://www.dailymotion.com/video/xgjrs4_yyyyyyyyyy-yyyyyyy-yyyyyyy-yyyyyy-yyyyyy_animals#hp-v-v11
-- http://www.dailymotion.com/video/xril8y_holland-0-2-germany-38-0-2-m-gomez-hd_sport#
