
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri, data
	script.tmp={}

	if origUrl:find('//sta.sh/') then
		debugSaveInc(logpref..'.html', usd.head(origUrl))
		origUrl = usd.getlocation()	-- redirect to deviantart.com
	end

	uri = URI.parse(origUrl)

	local artid = uri.path:match('^/art/[^/]-%-(%d+)$')
		or uri.path:match('^/download/(%d+)')
		or uri.host:find('%.deviantart%.net$') and tonumber(uri.path:match('%-d(%w+)%.%w+$') or '', 36)
		or uri.host=='fav.me' and tonumber(uri.path:match('^/d(%w+)$') or '', 36)

	if not artid and uri.host:find('%.deviantart%.net$') then
		debugLog('direct?')
		usd.setretresult(origUrl,0,1)
		return
	end

	if artid and not uri.host:find('%.deviantart%.com$') then
		debugSaveInc(logpref..'.html', usd.head('http://www.deviantart.com/view/'..artid) )
		if not usd.getheaders():find('HTTP/%d%.%d 200 OK') then
			dirUrl = origUrl
			dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)PRE/','http://fc%1')
			dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)%d+[HW]?/','http://fc%1')
			usd.setretresult(dirUrl,0,1)
			return
		end
		local l = usd.getlocation()
		usd.modquery(l)
		origUrl = l
		uri = URI.parse(origUrl)
	end


	local userid = uri.host:match('^([^.]+)')
	local gallery = uri.path:match('^/gallery/(%d+)') or (uri.query or ''):match('set=(%d+)')
	local favourites = uri.path:match('^/favourites/')
	local category = (uri.query or ''):match('catpath=%%2F(%w+)')

	if uri.host=='sta.sh' then
	    page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
		dirUrl = page:match('href="(http://sta.sh/download/[^"]+)"')
		if dirUrl then
			debugSaveInc(logpref..'.html', usd.head(entityDecode(dirUrl)))
			dirUrl = usd.getlocation()
		end
		page = usd.get('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl))
        data = parseJsObject(page) or {}
		debugSaveInc(logpref..'.html', page..'\r\n', serialize(data, nil, true))
		if data.type=='rich' and not dirUrl then	-- html
			debugLog('not supported')
			usd.setretresult('%notfound%')
			return
		end
		dirUrl = dirUrl or data.url or data.fullsize_url
		dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)PRE/','http://fc%1')
		script.tmp.newName = filterName( utf8ToAnsi(data.author_name..'-'..data.title..dirUrl:match('%.[^.]+$')), true)
		dirUrl = addNewName(dirUrl, script.tmp.newName)
		usd.setretresult(dirUrl, 0, 1)
		return
	end

	if not artid then	-- gallery
		local offset = tonumber( (uri.query or ''):match('offset=(%d+)') or 0 )

		local nextPage

		if uri.path=='/rss.xml' then
			nextPage = origUrl
		else
			uri.query = uri.query and uri.query:gsub('[&?]?offset=%d*','')
			if uri.path=='/' then uri.path='/gallery/' end

			if (uri.path=='/gallery/' or uri.path=='/favourites/') and not uri.query then	uri.query='catpath=%2F'	end
			origUrl = uri()

			local query = 'sort:time '..(favourites and 'favby:' or 'gallery:')..userid..(gallery and '/'..gallery or '')..(category and ' in:'..category or '')
			nextPage = 'http://backend.deviantart.com/rss.xml?q='..escapeUC(query)..'&type=deviation&offset='..offset
		end

		while nextPage do
			page = usd.get(nextPage)
			debugSaveInc(logpref..'.html', page)
			if usd.progstatus()==0 then break end
			for url in page:gmatch('<guid[^>]+>([^<]+)</guid>') do
				usd.addquery(entityDecode(url))
			end
			nextPage = page:match('<atom:link rel="next" href="([^"]+)"')
			if nextPage then
				nextPage = entityDecode(nextPage)
				offset = nextPage:match('offset=(%d+)')
				uri.query = (uri.query or ''):gsub('&?offset=%d*','')
				uri.query = uri.query..(#uri.query>0 and '&' or '')..'offset='..offset
				usd.modquery(uri())
				usd.waittime(1)
			end
		end

		if not nextPage then
			uri.query = (uri.query or ''):gsub('&?offset=%d*','')
			if uri.query=='' then uri.query=nil end
			usd.modquery(uri())
			usd.setretresult('%done%')
		end
		return
	end

	local username
	local title

	page = usd.get('http://backend.deviantart.com/embed/info.php?id='..artid)
	debugSaveInc(logpref..'.html', page)
	if page:find('<error>Deviation not found</error>') then
		page = usd.get('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl))
        data = parseJsObject(page) or {}
		debugSaveInc(logpref..'.html', page..'\r\n', serialize(data, nil, true))
		if usd.getheaders():find('HTTP/%d%.%d 404 Not Found') then
			if page:find('Deviation id %d+ is private') then
				page = usd.get(origUrl)
				debugSaveInc(logpref..'.html', page)
				dirUrl = page:match('<meta name="og:image" content="([^"]+)"')
				username = uri.host:match('^([^.]+)')
				title = page:match('<meta name="og:title" content="([^"]+)"')
			else
				return usd.setretresult('%notfound%')
			end
		end
		username = username or data.author_name
		title = title or data.title
		dirUrl = dirUrl or data.url or data.fullsize_url
		dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)PRE/','http://fc%1')
	end
	username = username or page:match('<username>([^<]+)</username>')
	title = title or page:match('<title>(.-)</title>')
	title = title:gsub('^<!%[CDATA%[(.-)%]%]>$','%1')
	title = entityDecode(title)
	dirUrl = dirUrl or page:match('<fileurl>([^<]+)</fileurl>')
	if dirUrl:find('^(fs%d+):') then dirUrl = dirUrl:gsub('^(fs%d+):',page:match('<onefifty>(http://[^/]+/)')..'%1/') end

	script.tmp.newName = filterName( utf8ToAnsi(username..'-'..pad(artid,9)..'-'..title..dirUrl:match('%.[^.]+$')), true)

	dirUrl = addNewName(dirUrl, script.tmp.newName)

	usd.setretresult(dirUrl, 0, 1)

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '.deviantart.com/', GDL, OS)
regDirSuccess( '.deviantart.net/fs', GDL, OS)
regDirSuccess( '//sta.sh/', GDL, OS)
regDirSuccess( '//fav.me/', GDL, OS)
