
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = tableCombine({document='zip',presentation='pptx',drawings='png',spreadsheet='xls'}, Settings[script.name] or {})
	debugLog(serialize(conf))

	script.tmp={}

	uri = URI.parse(origUrl)
	uri.query = (uri.query and uri.query..'&' or '')..'confirm=no_antivirus'
	origUrl = uri()	-- fragment

	if uri.path=='/open' then
		debugSaveInc(logpref..'.html', usd.get(origUrl))
		origUrl = usd.getlocation()
		--usd.modquery(origUrl)
		uri = URI.parse(origUrl)
	end

	local d, id, r = uri.path:match('^/([^/]+)/d/([^/]+)')

	if not d then
		d, r = uri.path:match('^/(spreadsheet)/(%w+)')
		id = d and uri.query:match('key=([^&]+)')
	end

	if r and (r~='ccc' and r~='lv') then
		debugLog(r..' is not supported')
		usd.setretresult('%notfound%')
		return
	end

	if not d then  d, id = origUrl:match('/(folder)view%?id=([^&]+)')  end

	if not d then
		d='file'
		id = id or origUrl:match('[?&]id=([^&]+)')
	end

	if not id then usd.setretresult('%notfound%') return end

	local function check(url)
		if url:find('^https:') then debugLog(url) end
		page = usd.get(url)
		debugSaveInc(logpref..'.html', page)
		local err = page:find('<p class="errorMessage"[^>]+>(.-)</p>')
		if err then usd.savetolog(utf8ToAnsi(err)) end
		if not usd.getlocation():find('docs.googleusercontent.com/',1,true)
			and ( page == ''
				or err
				or page:find('<meta[^>]-content="%d+; url=\'https?://www.google.com/accounts/ServiceLogin')
				or page:find('<title>Error 404')
				or page:find('<TITLE>Moved Temporarily</TITLE>')
			)
			then
			usd.savetolog('not supported or not found')
			usd.setretresult('%notfound%')
			return true
		end
		return
	end


	usd.get('http://docs.google.com/')	-- cookies!

	if d=='document' then
		if check('https://docs.google.com/'..d..'/d/'..id..'/edit') then return end
		script.tmp.rename = true
		dirUrl = ('http://docs.google.com/document/d/%s/export?format=%s&/%s'):format(id,conf[d],id)
		usd.setretresult(dirUrl, 1, 0) --    !
		return
	elseif d=='presentation' then
		if check('https://docs.google.com/'..d..'/d/'..id..'/present') then return end
		script.tmp.rename = true
		dirUrl = ('http://docs.google.com/%s/d/%s/export/%s?/%s'):format(d,id,conf[d],id)
		usd.setretresult(dirUrl, 1, 0)
		return
	elseif d=='drawings' then
		if check('https://docs.google.com/'..d..'/d/'..id..'/edit') then return end
		script.tmp.rename = true
		dirUrl = ('http://docs.google.com/%s/d/%s/export/%s?/%s'):format(d,id,conf[d],id)
		usd.setretresult(dirUrl, 1, 0)
		return
	elseif d=='spreadsheet' then
		script.tmp.rename = true
		usd.get('http://www.google.com/')	-- cookies!
		if check('https://docs.google.com/folderview?id='..id) then return end
		dirUrl = ('http://docs.google.com/spreadsheet/ccc?key=%s&output=%s&pref=2'):format(id,conf[d])
		usd.setretresult(dirUrl, 1, 0)
		return
	elseif d=='folder' then
		if check('https://docs.google.com/folderview?id='..id) then return end

		local count = tonumber(page:match('<div class="flip%-folder%-item%-count">[^<]-(%d+)') or -1)
		debugLog(count..' objects')
		local data = page:match('var data%s*=%s*({.+)')
		data = parseJsObject(data)
		debugSaveInc(logpref..'.html', serialize(data,nil,true),('%d folderModel, %d viewerItems'):format(#data.folderModel,#data.viewerItems),false)
		if count~=#data.folderModel then return usd.setretresult('%parsing error') end

		local vi = {}
		for k, v in ipairs(data.viewerItems) do
			vi[v[8]]=true
			local u = v[17]:gsub('([?&])usp=[^&]+','%1'):gsub('[?&]$','')
			local n = utf8ToAnsi(v[3]):gsub('[?%s]+','_')
			usd.addquery(u..'#'..n)
		end

		for k, v in ipairs(data.folderModel) do
			if not vi[v[2]] then
				usd.addquery(v[5]:gsub('([?&])usp=[^&]+','%1'):gsub('[?&]$',''))
			end
		end

		usd.setretresult('%done%')
		return
	end

	usd.get('http://docs.google.com/')	-- cookies!

	origUrl = 'https://docs.google.com/file/d/'..id..'/edit'
	if check(origUrl) then return end

	local data={download = page:match('"download":({.-})')}
	data.download = parseJsObject(data.download)
	debugSaveInc(logpref..'.html', serialize(data,nil,true),nil,false)

	script.tmp.newName = data.download.filename

	local restart, info = setPusdName(utf8ToAnsi(data.download.filename))
	if restart then return end

	local tmp = data.download.url:gsub('^https','http')
	debugSaveInc(logpref..'.html', usd.head(tmp))
	if usd.getlocation():find('.googleusercontent.com/',1,true) then
		dirUrl = tmp
	else
		page = usd.get(tmp)
		dirUrl = entityDecode(page:match('<a id="uc%-download%-link".-href="(.-)"'))
		dirUrl = URI.combine('http://docs.google.com/', dirUrl)()
	end


	local pusdsize = fileSize(info.localfile..'.pusd')
	if pusdsize then
		setHeader('Range: bytes='..pusdsize..'-')
	end


	usd.setretresult(dirUrl, 1, 1)
	return
end

regCheckError( {'//docs.google.com/','docs.googleusercontent.com/docs/'}, function (dirUrl,fullName,headers,currStatus) script.tmp.headers = headers end)

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	if script.tmp.rename or script.tmp.newName then
		local cd = script.tmp.headers:match('[\r\n]Content%-Disposition: attachment;%s*filename[^\r\n]+')
		local newName = cd:match("filename%*=UTF%-8''(.+)") or cd:match('filename="([^"]+)"')
		newName = utf8ToAnsi(script.tmp.newName or unescape(newName))
		return usd.setretresult(fileRename(fullName, newName))
	end
end

regDirSuccess( '//docs.google.com/', GDL, OS)
regDirSuccess( '//drive.google.com/', GDL, OS)
