
function GDL(origUrl) -- GetDirectLink
	usd.setstatus(script.name)
	local logpref = script.name .. '_GDL_v12'
	local dirUrl, page

	Storage[script.name] = Storage[script.name] or {}
	local st = Storage[script.name]

	local conf = tableCombine({
			  skipNonOriginalPics = false
			, photoTemplate = '%author%-%id%-%title%-%width%x%height%'
			, videoTemplate = '%author%-%id%-%title%-%width%x%height%'
	}, Settings[script.name])


	--local apiKey = conf.apiKey or usd.getoption(plg.plgname, script.name .. '_apiKey', '')
	local apiKey = conf.apiKey or st.apiKey or ''

	script.tmp = script.tmp or {}

	local function getKey()
		local form = Form.make {
			 action = 'http://www.flickr.com/services/api/explore/flickr.photos.getInfo'
			,method = 'post'
			,inputs = {
				 method = 'flickr.photos.getInfo'
				,enable_photo_id = 'on'
				,param_photo_id = math.random(8e9, 9e9)
				,param_secret = ''
				,format = 'rest'
				,sign_call = 'none'
			}
		}
		local page = form:submit()
		apiKey = page:match('[&?]api_key=(%x+)')
		debugSaveInc(logpref..'_key.html', page, 'key new: '..(apiKey or '<none>') )
		--usd.setoption(plg.plgname, script.name .. '_apiKey', apiKey or '')
		st.apiKey = apiKey
	end

	local function api(a)
		--local fApi = 'http://api.flickr.com/services/rest/?method=flickr.%s&api_key=%s&format=json&nojsoncallback=1'
		local fApi = 'https://api.flickr.com/services/rest/?method=flickr.%s&api_key=%s&format=json&nojsoncallback=1'
		--local page = usd.get(fApi:format(a, apiKey, 'photo', id))
		local page = usd.get(fApi:format(a, apiKey))
		if page:find('"message":"Invalid API Key') then
			debugSaveInc(logpref..'_key.html', page..'\r\n')
			getKey()
			page = usd.get(fApi:format(a, apiKey))
		end
        local data = parseJsObject(page) or {}
		debugSaveInc(logpref..'.html', page..'\r\n', serialize(data, nil, true))
		return data
	end

	local function getBig(url)
		if not url:find('%.static.?flickr%.com/%d+/(%d+)') then return end
		local tmp1, tmp2, tmp3 = url:match('^(.-)(%.%w+)$')
		tmp3 = tmp1:match('(_%w)$') or ''
		tmp1 = tmp1:gsub('(_%w)$','')
		if not tmp3:find('_[hko]') then tmp3 = '_b' end
		dirUrl = tmp1..tmp3..tmp2
		dirUrl = dirUrl:gsub('^https:','http:')
		if getLstInfo(true).url == url then usd.modquery(dirUrl) end
		usd.setretresult(dirUrl,1,1)
	end

	local short = origUrl:match('//flic.kr/p/(%w+)')	-- http://flic.kr/p/short
		or origUrl:match('/photo.gne?short=(%w+)')
	if short then
		debugSaveInc(logpref..'.html', usd.head('http://www.flickr.com/photo.gne?short='..short))
		origUrl = usd.getlocation()
	end

	local uri = URI.parse(origUrl)
	--uri.path = uri.path:gsub('/sizes/%w+/$',''):gsub('/page%d/$','/'):gsub('/with/%d+/$','/')
	origUrl = uri()


	local user = uri.path:match('^/photos/([^/]+)')
	local set = uri.path:match('^/photos/[^/]+/sets/(%d+)')
	local group = uri.path:match('^/groups/([^/]+)')
	local photo = uri.path:match('/photos/[^/]+/(%d+)')
			or origUrl:match('%.static.?flickr%.com/%d+/(%d+)')
			or origUrl:match('photo%.gne%?id=(%d+)')


	if photo then
		local data = api('photos.getInfo&photo_id='..photo)

		if data.stat=='fail' then
			usd.savetolog(data.message)
			usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
			return getBig(origUrl)
		end

		local info = {
			  id     = photo
			, author = data.photo.owner.username
			, title  = data.photo.title._content
			, video  = data.photo.video
			, media  = data.photo.media
		}

		if origUrl:find('%.static.?flickr%.com/') or origUrl:find('photo.gne?id=',1,true) then
			origUrl = data.photo.urls.url[1]._content
			usd.modquery(origUrl)
		end

		if info.media == 'photo' then
			local exif = api('photos.getExif&photo_id='..photo)
			if exif.stat=='ok' then
				if not next(exif.photo.exif) then
					usd.waittime(2)
					exif = api('photos.getExif&photo_id='..photo)
				end
				info.camera = exif.photo.camera
				for _, v in ipairs(exif.photo.exif) do
					info[v.tag] = v.raw._content
					info[v.tag..'_clean'] = v.clean and v.clean._content or nil
				end
			end
		end

		data = api('photos.getSizes&photo_id='..photo)
		local pdata

		local maxw=0
		for k, v in ipairs(data.sizes.size) do
			if v.media == info.media
				and not v.source:find('flickr.com/apps/')		-- source = "file.swf", label = "Video Player"
				and (v.width > maxw  or  v.label == "Original")
				then
				if 	not info.video or v.width <= info.video.width
					then
					dirUrl = v.source
					maxw = v.width
					pdata = v
				end
			end
		end

		info.width = pdata.width
		info.height = pdata.height

		debugSaveInc(logpref..'.html', serialize(info, nil, true), nil, false)

		if conf.skipNonOriginalPics and pdata.label~="Original" then
			usd.savetolog('no original')
			return usd.setretresult(unpack(conf.skipNonOriginalPics==2 and {'%notfound%'} or {'%no original', 2}))
		end

		local t = conf[info.media..'Template'] or '%title%'
		script.tmp.newName = type(t)=='function' and t(info) or t:gsub('%%([%w_-]+)%%',info)
		script.tmp.newName = filterName(utf8ToAnsi( script.tmp.newName ) ):gsub('[%s_]+','_'):gsub('_?%-_?','-')
		--debugLog('newName: '..script.tmp.newName)

		if info.video then
			debugSaveInc(logpref..'_video.html', usd.head((dirUrl:gsub('^https:','http:'))), 'video')
			dirUrl = usd.getlocation()
		end
		dirUrl = dirUrl:gsub('^https:','http:')
		usd.setretresult(dirUrl, 0, 1)
		return
	end	-- photo


	if set then
		local pagenum = 1
		repeat
			local data = api('photosets.getPhotos&photoset_id='..set..'&page='..pagenum)
			if data.stat=='fail' then
				usd.savetolog(data.message)
				usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
				return
			end
			for k,v in ipairs(data.photoset.photo) do
				usd.addquery(('http://www.flickr.com/photos/%s/%s#%s'):format(data.photoset.owner,v.id,filterName(utf8ToAnsi(v.title),true)))
			end
			pagenum = pagenum+1
		until pagenum > data.photoset.pages
		return usd.setretresult('%done%')
	end


	if user then
		if not user:find('^%d+@N%d%d$') then  user = api('urls.lookupuser&url='..origUrl).user.id  end
		local pagenum = 1
		repeat
			local data = api('people.getPhotos&user_id='..user..'&page='..pagenum)
			if data.stat=='fail' then
				usd.savetolog(data.message)
				usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
				return
			end
			for k,v in ipairs(data.photos.photo) do
				usd.addquery(('http://www.flickr.com/photos/%s/%s#%s'):format(v.owner,v.id,filterName(utf8ToAnsi(v.title),true)))
			end
			pagenum = pagenum+1
		until pagenum > data.photos.pages
		return usd.setretresult('%done%')
	end


	if group then
		if not group:find('^%d+@N%d%d$') then  group = api('urls.lookupgroup&url='..origUrl).group.id  end
		local pagenum = 1
		repeat
			local data = api('groups.pools.getPhotos&group_id='..group..'&page='..pagenum)
			if data.stat=='fail' then
				usd.savetolog(data.message)
				usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
				return
			end
			for k,v in ipairs(data.photos.photo) do
				usd.addquery(('http://www.flickr.com/photos/%s/%s#%s'):format(v.owner,v.id,filterName(utf8ToAnsi(v.title),true)))
			end
			pagenum = pagenum+1
		until pagenum > data.photos.pages
		return usd.setretresult('%done%')
	end



	debugLog('not a gallery or picture page')
	usd.setretresult('%notfound%')
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess('.flickr.com/', GDL, OS)
regDirSuccess('//flickr.com/', GDL, OS)
--regDirSuccess('.static.flickr.com/', GDL, OS)
regDirSuccess('.staticflickr.com/', GDL, OS)
regDirSuccess('//flic.kr/', GDL, OS)
