
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)

	local conf = Settings and Settings[script.name:gsub('_v%d+$','')]
		or { interactive = false, remember = false }

	origUrl = origUrl:match('^([^#]+)')

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	if page:find('tracktrk%.net')
		or page:find('illivid')
		then
		local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
		usd.setstatus(msg)
		usd.savetolog(msg)
	end

	--The file you tryed to download does not exist or has been removed due to copyright infringement.
	local err = page:match('<div id="main">%s*<!%-%- content of main %-%->%s*<div class="content">%s*<br /><center><b>(.-)</b>')
	if err then
		usd.savetolog(err)
		if err:find('does not exist') then
			usd.setretresult('%notfound%')
		end
		return
	end

	script.tmp={}
	usd.waittime(2,2)

-----------------
	--local name, size = page:match( '>File : (.-)<br />Size : (.-)<' )
	local name, size = page:match( '<br /><h6>([^(<]-) %(([^)]+)%)' )

	local mirrors = {}
-----------------
	--for url in page:gmatch( '<td><img src="images/host/[^"]+" /></td>%s*<td><a href="(.-)"' ) do
	--for url in page:gmatch( '<a href="([^"]+)" class="dl"' ) do
	usd.relocationmode(0)
	for url in page:gmatch( 'href%s*=%s*[\'"]%s*(http://[^/]+/rd/[^\'"]+)' ) do
		url = url:gsub('[\r\n]+',''):gsub('%s*$','');
		usd.waittime(1)
		if not (url:find('tracktrk') or url:find('/premium')) then
			local tmp = usd.get(url)
			debugSaveInc(logpref..'.html', tmp)
			url = tmp:match('window.location%s*=%s*"(.-)%s*"')
				or usd.getheaders():match('%s[Ll]ocation: ([^\r\n]+)')
			table.insert(mirrors, url)
		end
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		else
			debugLog('m.lua not loaded!')
		end
	end

	local info = { {'Name: '..(name or '<noname>')}, {'Size: '..(size or'<nosize>')} }
	local status, _ = getMirror(mirrors, conf.preferred, conf.interactive, info)
	if status then
		script.tmp.mirror = _
	end

	return
end

function OS(origUrl, dirUrl, fullName)
	if not (script.tmp and script.tmp.mirror) then
		return
	end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( '//go4up.com/', GDL, OS)	-- '//go4up.com/dl/',  '//go4up.com/link.php'
