
function GDL(origUrl) 	-- GetDirectLink

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, remember = false }
	end

	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	script.tmp={}

	usd.setcookie('jlanguage=en-US')
	origUrl = origUrl:gsub('^([^/]+//[^/]+)/[^/]+/([^/]+).*$','%1/download/%2')

	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	usd.waittime(2,2)

	page = usd.get(page:match('<a href="(/mirrors/[^"]+)"'))
	debugSaveInc(logpref..'.html', page)

-----------------
	local name, size = page:match('<h1 class="filename">(.-)</h1>%s*<p>Size : <span class="orange">(.-)</span>')

	local mirrors = {}
-----------------
	usd.waittime(3,3)

	local ref = usd.getlocation()
	local uri = URI.parse(ref)
	local redirect = page:match("redirect_url%s*=%s*'(.-)';")

	usd.relocationmode(0)
	for r in page:gmatch( 'href="(/redirect/[^"]+)' ) do
		usd.setreferer(ref)
		debugSaveInc(logpref..'.html', usd.get( uri(r)() ))
		local url = usd.getheaders():match('%sLocation: (http[^\r\n]+)')
		if url then
			table.insert(mirrors, url)
		end
		usd.waittime(1)
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, conf.preferred, conf.interactive, info)
end

regDirSuccess( '.jheberg.net/', GDL, OS)
regDirSuccess( '//jheberg.net/', GDL, OS)
