
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v19'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form

	origUrl = origUrl:gsub('%.com/%?', '.com/download/')
	origUrl = origUrl:gsub('%.com/download%.php%?', '.com/download/')
	origUrl = origUrl:gsub('%.com/file/', '.com/download/')
	origUrl = origUrl:gsub('%.com/view/', '.com/download/')

	local uri = URI.parse(origUrl)
	local pass = uri.userinfo
	origUrl = uri()
	local qkey = uri.path:match('/download/([^?&#/]+)') or uri.query

	local getInfo = function(qk)
		local page = usd.get('http://www.mediafire.com/api/file/get_info.php?response_format=json&version=2&quick_key='..qk)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page..'\r\n', data and serialize(data, nil, true))
		local data2 = data
		if data.response.result ~= 'Success' then
			page = usd.get('http://www.mediafire.com/api/folder/get_info.php?response_format=json&version=2&folder_key='..qk)
			data = parseJsObject(page)
			debugSaveInc(logpref..'.html', page..'\r\n', data and serialize(data, nil, true))
		end
		return data, data2
	end

	if uri.query and uri.query:find(',') then
		for qk in uri.query:gmatch('([^,]+)') do
			local data = getInfo(qk).response.file_info
			usd.addquery(('http://www.mediafire.com/download/%s/%s-%s'):format(
				  data.quickkey
				, filterName(utf8ToAnsi(data.filename)):gsub('%s+','_'):gsub("'",'')
                , string.format('%0.2f', data.size / 1024 / 1024) .. 'MB'
            ))
		end
		usd.setstatus('done')
		usd.waittime(3)
		usd.setretresult('%done%')
		return
	end

	if script.cookie then
		usd.setcookie(script.cookie, 1)
	end

	local data, data2 = getInfo(qkey)
	data = data.response

	if data.result ~= "Success" then
		if data.error == 110
			or data.error == 112
			or data.message == "Unknown or Invalid QuickKey" and data.message == data2.response.message
			then
			usd.setretresult('%deleted%')
		else
			usd.setretresult('%'..data.message)
		end
		return
	end

	if data.folder_info then
		local key = uri.query

		local f = Form.make({
			  action = 'http://www.mediafire.com/api/folder/get_content.php'
            , inputs = {
            	  filter = 'all'
            	, order_by = 'name'
            	, order_direction = 'asc'
            	, version = 2
            	, response_format = 'json'
            }
		})
		local err
		local function getfiles(key)

			local function get2(key, ctype, chunk)
				f.inputs.folder_key = key
				f.inputs.content_type = ctype
				f.inputs.chunk = chunk
				local page = f:submit()
				data = parseJsObject(page) or {}
				debugSaveInc(logpref..'.html', page..'\r\n', serialize(data,nil,true))
				return data
			end

			local data

			local function getFiles2(chunk)
				chunk = chunk or 1
				data = get2(key, 'files', chunk).response

				if data.result ~= "Success" then
					err = data.message or 'unknown error'
					return
				end

				data = data.folder_content

				for k, v in ipairs(data.files ) do
					usd.addquery(('http://www.mediafire.com/download/%s/%s-%s'):format(
						  v.quickkey
						, filterName(utf8ToAnsi(v.filename)):gsub('%s+','_'):gsub("'",'')
		                , string.format('%0.2f', v.size / 1024 / 1024) .. 'MB'
		            ))
				end
				if #data.files == data.chunk_size then getFiles2(chunk+1) end
			end
			getFiles2()

			data = nil

			local function getFolders(chunk)
				chunk = chunk or 1
				data = get2(key, 'folders', chunk).response.folder_content

				for k, v in ipairs(data.folders) do
					getfiles(v.folderkey)
				end
				if #data.folders == data.chunk_size then getFolders(chunk+1) end
			end
			getFolders()
		end

		getfiles(key)

		if err then
			usd.savetolog('Error: '..err)
			if err == 'Unknown or invalid FolderKey' then
				usd.setretresult('%notfound%')
				return
			end
			usd.setretresult('%'..err)
			return
		end

		usd.setstatus('done')
		usd.waittime(5)
		usd.setretresult('%done%')
		return
	end

	newName = data.file_info and data.file_info.filename
	newName = newName and utf8ToAnsi(newName)

	--origUrl = data.file_info.links.normal_download

	local h = usd.head(origUrl)
	debugSaveInc(logpref..'.html', h)
	--if h:find(data.file_info.mimetype,1,true)

	if h:find('Content-transfer-encoding: binary',1,true)
		and h:find('Content-Length:',1,true)
		then
		usd.setretresult(usd.getlocation(),1,1)
		return
	end


	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	usd.relocationmode(0)

	if page:find('name="form_captcha"')
		and Accounts['mediafire.com']
		then
		local a = Accounts['mediafire.com']
		local loginform = page:match('<form name="form_login1".-</form>')
		loginform = Form.parse(loginform)
		loginform.inputs.login_email = a[1].login
		loginform.inputs.login_pass = a[1].password
		local loginpage = loginform:submit()
		debugSaveInc(logpref..'.html', loginpage, 'login')
		script.cookie = usd.getcookie()
		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
	end


	local h = usd.getheaders()
	local l = h:match('%sLocation: ([^\r\n]+)')
	if h:find('Content%-Type: text/html') and l then
		page = usd.get(l)
		debugSaveInc(logpref..'.html', page, 'redirect1')
	end


	local form = page:match('<form name="form_captcha".-</form>')
	if form then
		usd.relocationmode(1)
		local key = form:match('%?k=([^"]+)')
		form = Form.parse(form)
		form.action = uri(form.action)()
		form.inputs.recaptcha_response_field
			, _, form.inputs.recaptcha_challenge_field
				= queryReCaptcha(key, 0, nil, nil, nil, true) -- gooCheck
		page = form:submit()
		debugSaveInc(logpref..'.html', page)
		local l = usd.getheaders():match('%sLocation: ([^\r\n]+)')
		if l then
			page = usd.get(uri(l)())
			debugSaveInc(logpref..'.html', page)
		end

		if page:find('<form name="form_captcha"') then
			usd.setretresult('%Bad captcha?')
			return
		end
	end

	usd.relocationmode(0)

	form = page:match('<form name="form_password".-</form>')
	if form then
		pass = pass or prompt('Password for '..origUrl)
		form = Form.parse(form)
		form.action = uri(form.action)()
		form.inputs.downloadp = pass
		page = form:submit()
		debugSaveInc(logpref..'.html', page, "form_password")

		if page:find('<form name="form_password"') then
			usd.setretresult('%Need password for download! Enter it to link: http://PaSsWoRd@')
			return
		end
	end

    local dirUrl = usd.getheaders():match('Location: ([^%s]+)', 2)
    	or page:match('%skNO%s*=%s*"([^"]+)"')
        or page:match("<a href='([^']+)' target='workframe2'>")
        or page:match('<div class="download_link"[^<]+<a[^>]-href="([^"]+)"')

  	if not dirUrl then
  		local err = page:match('<p class="error%-msg"> <b>.-</b>')
  			or page:match('class="error_msg_title">([^<]+)')
  		if err then
  			err = entityDecode(err:gsub('<[^>]+>',''):gsub('^%s*(.-)%s*$','%1'))
  			usd.setretresult('%'..err)
  			return
  		end
  		return usd.setretresult('%plugindefect')
  	end

	if dirUrl:find('/error.php?errno=',1,true) then
		usd.savetolog('Redirect: '..dirUrl)
		usd.setretresult('%notfound%')
		return
	end

	usd.setretresult(dirUrl, math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, newName))
end

regDirSuccess( '.mediafire.com/', GDL, OS)
