--GDL

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	local conf = Settings[script.name] or {qualityList={'1080p','720p','360p'},interactive=false}

	local fmt = origUrl:match('#fmt=(%w+)')
	origUrl = origUrl:match('^([^#]+)')

	page = shitFlare(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<div class="podcontent">%s*<p[^>]+>[^<]- (requires a Newgrounds account)')
	if err then
		usd.savetolog(err)
		usd.setretresult('%notfound%')
		return
	end

	script.tmp={}

    local ec = page:match('new embedController%(%[{.-</script>')

    dirUrl = ec:match('"url":"([^"]+)"')
	if dirUrl then
	    dirUrl = dirUrl:gsub('\\u00','%%'):gsub('\\','')
	else
		dirUrl = page:match('src="(http://art.ngfiles.com/images/[^"]+)"')
	end

	if dirUrl:find('/%d+_alternate_%d+.*%.zip$') then
		usd.savetolog('Not supported')
		usd.setretresult('%notfound%')
		return
	end

	local title = page:match('<meta property="og:title" content="([^"]+)"')
	local author = page:match('<ul class="authorlinks">.-<em>[^<]+<a href="[^"]+">([^<]+)')
	local id = page:match('"item_id":(%d+)')
	id = id and '-'..pad(id,7) or ''
	local newName = utf8ToAnsi(author..id..'-'..title..dirUrl:match('%.%w+$'))

	local video, vext = dirUrl:match('^(.-)(%.mp4)$')

	if not video then
		newName = filterName(newName, true)
		dirUrl = addNewName(dirUrl, newName)

		usd.setretresult(dirUrl, math.random(2,4), 1)
		return
	end


	if fmt then
		debugSaveInc(logpref..'.html', usd.head(video..'.'..fmt..vext))
		usd.setretresult(addNewName(usd.getlocation(), filterName(newName, true)), math.random(2,4), 1)
		return
	end

	local urls, info = {}, {}

	for k,v in ipairs(conf.qualityList) do
		local vurl = video..'.'..v..vext
		usd.setreferer(origUrl)
		debugSaveInc(logpref..'.html', usd.head(vurl) )
		local h = usd.getheaders():lower()
		if not h:match('http/%d%.%d 404 not found') then
			local size = h:match('http/%d%.%d 200 ok') and h:match('content%-length: (%d+)')
			size = size and string.format('%0.2f', size / 1024 / 1024) or ' ??????'
			if size then
				urls[v] = usd.getlocation()
				table.insert(info, ('%s: %s MB'):format(pad(v,5,'  '), pad(size, 7, '  ')) )
			end
		end
	end

debugSaveInc(logpref..'.html', serialize({urls=urls, info=info},nil,true), nil, false )

	if conf.interactive then
		local duration = tonumber(page:match("'viddur': (%d+)"))
		duration = math.floor(duration / 60)..':'..pad(duration % 60, 2)
		local desc = entityDecode(page:match('<meta name="description" content="([^"]+)"'))
		local dlg = {
			{duration, title}
            , {desc}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		if usd.progstatus() == 0 then
			debugLog('USD stopped')
			return
		end
		local q = dlg:show()
		if q == '' then debugLog('Esc') return end		-- esc
debugLog(q)
		q = q:match('quality=([%d]+)') + 1	--     0
		fmt = info[tonumber(q)]:match('^%s*(%w+)')
		usd.modquery(origUrl .. '#fmt='..fmt)
		usd.setretresult( addNewName(urls[fmt], filterName(newName, true)), 0, 0 )
		return
	end

	for k, fmt in ipairs(conf.qualityList) do
		if urls[fmt] then
			usd.modquery(origUrl .. '#fmt='..fmt)
			usd.setretresult( addNewName(urls[fmt], filterName(newName, true)), 0, 0 )
		end
	end


end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.newgrounds.com/', GDL, OS)
