
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v12'
	usd.setstatus(script.name)
	local conf = Settings[script.name] or {}

	debugLog(serialize(conf))

	local id, fname = origUrl:match('//rapidshare.com/#!download|%w+|(%d+)|([^|]+)')
	if not id then
		id, fname = origUrl:match('/desktop/[^/]+/[^/]+/(%d+)/([^/]+)/')
		fname = fname and base64.dec(fname)
	end
	if not id then	id, fname = origUrl:match('/files/(%d+)/([^/?&#]+)')	end

	local page = usd.get('http://api.rapidshare.com/cgi-bin/rsapi.cgi?sub=download&bin=1&fileid='..id..'&filename='..fname)
	debugSaveInc(logpref..'.html', page)

--ERROR: File not found. (e029a7af)
--ERROR: Daily traffic exhausted, upgrade now! (9fe01260)

	local err = page:match('^ERROR: ([^(]-) %(')
	if err=='File not found.' then
		return usd.setretresult('%notfound%')
	elseif err then
		return usd.setretresult('%'..err)
	end

	local srv = page:match('DL:([^,]+)')
	local dirUrl = 'http://'..srv..'/cgi-bin/rsapi.cgi?sub=download&bin=1&fileid='..id..'&filename='..fname
	debugSaveInc(logpref..'.html', usd.head(dirUrl))

	if not conf.chunkedMode then
		usd.setretresult(addNewName(dirUrl, fname),1,1)
		return
	end

	local fsize = tonumber(usd.getheaders():match('Content%-Length: (%d+)'))

	local restart, info = setPusdName(fname)
	if restart then return end

	local pusd = info.localfile..'.pusd'
	local pusdsize = fileSize(pusd) or 0
	local chunkSize = conf.chunkSize or 1024*1024
	local chunkPause = conf.chunkPause or 1
	local tmpfile = table.concat({usd.workdir..script.name, plg.plgname, plg.exename..'.tmp'}, '-')
	usd.setstatus(('Downloading: %0.2f MB'):format(fsize/1024/1024))
	local limit = fsize-1-chunkSize-1024
	for i = pusdsize, limit, chunkSize do
	    local chunkEnd = math.min(i+chunkSize-1, fsize-1)
		local range = 'Range: bytes='..i..'-'..chunkEnd
		setHeader(range)
		usd.get(dirUrl..'|'..tmpfile)
		setHeader(range, true)
		local headers = usd.getheaders()
		debugLog(headers)
		local size = chunkEnd-i+1
		local cl = tonumber(headers:match('Content%-Length: (%d+)'))
		if cl ~= size
			or not headers:find('Content-Type: application/octet-stream',1,true)
			then
			error('Wrong headers!')
		end
		local tmp = fileRead(tmpfile)
		if #tmp ~= size then error('Wrong size: '..size..' <> '..#tmp..' '..tmpfile) end
		fileAppend(pusd, tmp)
		usd.waittime(chunkPause)
	end
	os.remove(tmpfile)

	usd.setretresult(dirUrl,1,1)

end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.rapidshare.com/', GDL, OS)
regDirSuccess( '//rapidshare.com/', GDL, OS)
