
function GDL(origUrl) 	-- GetDirectLink

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, remember = false }
	end

	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}
	usd.waittime(2,2)

	local name, size = page:match( '<h2>Filename: <span title="([^"]+)">.-%((.-)%)</h2>' )

	local mirrors = {}
	for url in page:match('<table class="links".-</table>'):gmatch( 'href="(http[^"]+)' ) do
		table.insert(mirrors, url)
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local info = { {'Name: '..name}, {'Size: '..size} }
	local status, _ = getMirror(mirrors, conf.preferred, conf.interactive, info)
	if status then
		script.tmp.mirror = _
	end

	return
end

function OS(origUrl, dirUrl, fullName)
	if not (script.tmp and script.tmp.mirror) then
		return
	end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( '//sharebee.com/', GDL, OS)
