
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = Settings[script.name] or { client_id='YOUR_CLIENT_ID', lossless=false}
	script.tmp={}


	local function api(req, rdata)
		rdata = rdata or {}
		if not rdata.client_id then rdata.client_id = conf.client_id end
		local url = ('http://api.soundcloud.com/%s.json?%s'):format(req, tableConcat(rdata,'=','&'))
		local page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))
		return data
	end

	uri = URI.parse(origUrl)

--https://w.soundcloud.com/player/?url=http%3A%2F%2Fapi.soundcloud.com%2Ftracks%2F123&visual=true&liking=false&sharing=false&auto_play=false&show_comments=false&continuous_play=false&origin=tumblr
	if uri.host=='w.soundcloud.com' then
		origUrl = unescape(uri.query:match('url=(http[^&]+)'))
		uri = URI.parse(origUrl)
	end


	local data
--http://api.soundcloud.com/tracks/123/stream
	if uri.host=='api.soundcloud.com' then
		data = api(uri.path:match('^/([^/]+/[^/]+)'))
		origUrl = data.permalink_url
	else
		data = api('resolve', {url=origUrl})
	end

	usd.modquery(data.permalink_url)

	if data.kind=='user' then
		local id = data.id
		data = api('users/'..id..'/playlists')
		for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
		data = api('users/'..id..'/tracks')
		for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
		usd.setretresult('%done%')
		return
	end

	if data.kind=='playlist' then
		for k, v in ipairs(data.tracks) do usd.addquery(v.permalink_url) end
		usd.setretresult('%done%')
		return
	end

	if data.kind=='track' then
		script.tmp.newName = filterName(utf8ToAnsi(data.user.username..'-'..data.title), true)
		local f = data.original_format or ''
		-- aiff, wav, flac, m4a, mp3
		dirUrl = (f~="wav" and f~='aiff') and (f~='flac' or conf.lossless) and data.download_url or data.stream_url
		debugSaveInc(logpref..'.html', usd.head(dirUrl..'?client_id='..conf.client_id) )
		dirUrl = addNewName(usd.getlocation(), script.tmp.newName)
		--dirUrl = usd.getlocation()
		usd.setretresult(dirUrl, 0, 1)
		return
	end

	usd.setretresult('%plugindefect')
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	local ext = URI.parse(dirUrl).path:match('%.%w+$')
	return usd.setretresult(fileRename(fullName, script.tmp.newName, ext))
end


regDirSuccess( '//soundcloud.com/', GDL, OS)
regDirSuccess( '.soundcloud.com/', GDL, OS)
