-- GDL

local conf = Settings[script.name] or {
	apiKey='fuiKNFp9vQFvjLNvx4sUwti4Yb5yGutBN4Xh10LXZhhRKjWlV4'	-- Tumbo
    , mirrors = {'.tumblr.com/', '//tmblr.co/'}
}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri


	local function api(blog, method, req, search)
		local page = usd.get(('http://api.tumblr.com/v2/blog/%s/%s?%s&api_key=%s'):format(blog, method, tableConcat(req,'=','&'), conf.apiKey)..(search and '&tag='..search or ''))
        local data = parseJsObject(page) or {}
		debugSaveInc(logpref..'.html', page..'\r\n', serialize(data, nil, true))
		return data
	end

	uri = URI.parse(origUrl)

	if uri.host=='tmblr.co' or uri.host=='www.tumblr.com' then
		debugSaveInc(logpref..'.html', urlHead(origUrl, ''))
		origUrl = usd.getlocation()
		uri = URI.parse(origUrl)
	end

--text, quote, link, answer, chat, video, audio, photo
	local supported = tableKeys('video', 'audio', 'photo', 'text')


--http://blog.tumblr.com/
	local search = uri.path:match('^/search/([^/]+)')	or uri.path:match('^/tagged/([^/]+)')


	if uri.path == '/' or search then
		debugLog('search start')
	    local offset = 0
	    --local data = {response={total_posts=math.huge}}
	    search = search and search:gsub('%-',' ')
	    repeat
	    	local data = api(uri.host, 'posts', {offset=offset}, search)
	        usd.setstatus(offset..' / '..data.response.total_posts)
	    	offset = offset + #data.response.posts
	    	for _, v in ipairs(data.response.posts) do
				if supported[v.type] then usd.addquery(v.post_url) end
	    	end
	    until ( data.response.total_posts <= offset )
	    debugLog('search end')
	    usd.setretresult('%done%')
	    return
	end

	if uri.host:find('media.tumblr.com$') then return usd.setretresult(origUrl,1,1) end

	if uri.host=='www.tumblr.com' then
		local n = uri.fragment and uri.fragment:match('#newName=(.+)')
		debugSaveInc(logpref..'.html', usd.head(uri()))
		dirUrl = (usd.getlocation():gsub('#.*$',''))
		dirUrl = addNewName(dirUrl, n)
		usd.setretresult(dirUrl,1,1)
		return
	end


	local function get(url)
		debugLog('get: '..tostring(url))
		if not url then return false end
		local host = getHost(url)
		if not host then
			usd.savetolog('Bad url')
			return false
		end
		if host:find('.tumblr%.com$') or uri.path=='/' then return false end

		local h = usd.head(url)
		debugSaveInc(logpref..'.html', h)
		local len = h:lower():match('content%-length: (%d+)')
		if h:find('HTTP/%d%.%d 404')
			or len and tonumber(len)<44
			or usd.getlocation():find('/pixel.gif$')
			then
			return false
		end

		local status, _ = getMirror({url})
		if status then
			if getLstInfo().url == origUrl then usd.modquery(url) end
			return true
		end
		return false
	end


--http://blog.tumblr.com/post/1234
	local id = uri.path:match('^/post/(%d+)')
		or uri.path:match('^/image/(%d+)')
		or uri.path:match('^/reblog/(%d+)')

	if id then
		debugLog('id start')
		local data = api(uri.host, 'posts', {id=id})
		if data.meta.status==404 then return usd.setretresult('%notfound%') end

		local post = data.response.posts[1]

		if not supported[post.type] then
			debugLog('id end - wrong type: '..post.type)
			usd.setretresult('%notfound%')
			return
		end

--'link': post.url ?

		--if get(post.permalink_url) or get(post.link_url) then return end
		if get(post.permalink_url) then return end

		local newName = {data.response.blog.name, post.id}
		if post.slug~='' then table.insert(newName,post.slug) end
		newName = table.concat(newName, '-')

		if post.type == 'photo' then
			local photos = {}
			if conf.skip and #conf.skip>0 then
				for k, v in ipairs(post.photos) do
					local skip = false
					for ks, vs in ipairs(conf.skip) do
						if v.alt_sizes[1].url:find(vs) then
							debugLog('Skip '..v.alt_sizes[1].url)
							skip = true
							break
						end
					end
					if not skip then table.insert(photos, v) end
				end
			else
				photos = post.photos
			end

			if #photos==1 then
				usd.setreferer('')
				dirUrl = photos[1].original_size.url
				if dirUrl:find('^http://www.tumblr.com/') then
					debugSaveInc(logpref..'.html', usd.head(dirUrl))
					dirUrl = (usd.getlocation():gsub('#.*$',''))
				end
				dirUrl = addNewName(dirUrl, newName)
				usd.setretresult(dirUrl, 1, 1)
				debugLog('id end - 1 photo')
				return
			else
				local l = #tostring(#photos)
				for k, v in ipairs(photos) do
					local n = newName .. (v.caption and v.caption~='' and ('-'..v.caption) or '')..'-'..pad(k,l)
					local dir = v.original_size.url
					if dir:find('^http://www.tumblr.com/') then
						dir = dir..'#newName='..n
					else
						dir = addNewName(dir, n)
					end
					usd.addquery(dir)
				end
				debugLog('id end - photo')
				usd.setretresult('%done%')
				return
			end

		elseif post.type == 'video' then
			if not post.video_url then return usd.setretresult('%notfound%') end
			dirUrl = addNewName(post.video_url, newName)
			usd.setretresult(dirUrl,1,1)
			debugLog('id end - video')
			return

		elseif post.type == 'audio' then
			if get(post.source_url) or get(post.audio_url) then return debugLog('id end - audio') end
			usd.setretresult('%plugindefect audio')
			return

		elseif post.type == 'text' then
			local urls = {}
			for u in post.body:gmatch('<iframe[^>]- src="(https?://.-)"') do  table.insert(urls, u) end
			for u in post.body:gmatch('<img[^>]- src="(https?://.-)"') do
				local name = post.blog_name..'-'..post.id..'-'..post.slug..'-'..pad(counters[script.name..post.id], 2)
				table.insert(urls, addNewName(u, name) )
			end
			if #urls==1 then return get(urls[1]) end
			for k, v in ipairs(urls) do usd.addquery(v) end
			usd.setretresult('%done%')
			return
		end

		debugLog('id end - unknown type ?')
	end


end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( conf.mirrors, GDL, OS )
