--[[
local conf = Settings and Settings[script.name]
if not conf then
	-- defaults
	conf = { option1=12345, option2='test', option3={11,22,'something',33} }
end
local a1 = conf.option3[2] -- 22
local a2 = conf.option1    -- 12345
]]

Settings['<misc>'] = {
	modqueryPause	 = 4	--  4 
	, getLstInfoPause = 3				--  3 
	, getResumeFlagLimit = 128*1024		--    getResumeFlag()
	, subdirs = { 'B3T6', 'kotgar' }	--   
	--, saveCookiesTo = usd.workdir..'cookies.'..plg.exename..'.'..plg.plgname..'.txt' 
	--, extDownloader --    true,  DoWithLink  .ini   0.
	, logSupportedHosts = false			--        
	--, crutchHttp = 'http://www.google.com/none'	--     
        , tempDir = [[%TEMP%]]
	, convert = [[CAP\convert.exe]]			-- ImageMagick.org
	--, extIP = 'http://icanhazip.com/'	--      extIPservices
	, extIPservices = {
		  'http://icanhazip.com/'
		, 'http://curlmyip.com/'
		, 'http://canihazip.com/s'
		, 'http://ip-api.com/csv/?fields=query'
		, 'http://ident.me/'
		, 'http://ip.appspot.com/'
		, 'http://checkip.dyndns.org/'
		, 'http://www.trackip.net/ip'
		, 'http://l2.io/ip'
		, 'http://eth0.me/'
		, 'http://tnx.nl/ip'
		, 'http://myip.dnsomatic.com/'
		, 'http://ip.telize.com/'
		, 'http://checkip.amazonaws.com/'
		, 'http://hostna.me/'
		, 'http://ip.jmainguy.com/'
		, 'http://whatismyip.akamai.com/'
		, 'http://gbshouse.com/ip.php'
		, 'http://utils.admin-linux.fr/ip.php'
	}
}

Settings['<getMirror>'] = {
	interactive = true
	, useMega = true		--    mega.co.nz ( )
	, preferred={
		'sendfile.su'
		, 'hu.lk', 'hulkshare.com'
		, 'rapidshare.com'
		, '2shared.com'
		, '1fichier.com'
		, 'fileplanet.com.ua'
		, 'verzend.be'
		, 'filerio.in'
		, 'depositfiles.com'
		, 'uploading.com'
		, 'mediafire.com'
		, 'jumbofiles.com'
	}
	, unwanted = {
		'extabit.com'
		, 'uploaded.net', 'uploaded.to', 'ul.to'
		, 'hitfile.net'
	}
	, paidshit = {	
	}
}

Settings['<Dialog>'] = {
	sound = usd.workdir .. [[sound\test01.wav]]
	, soundflags = SND_ASYNC
	, beep = {111,111, 222,111, 333,111, 444,111}
}

Settings['<rtmpgw>'] ={
	gateway = 'http://127.0.0.1:12345/'
	, gatewayCmd = usd.workdir .. [[rtmpdump\rtmpgw.exe --device 127.0.0.1 --sport 12345]]
	, gatewayCmdFlags = SW_HIDE	-- SW_HIDE    
	, gatewayCmdPause = 3		--    -   
	--, gatewayKillCmd = [[taskkill /im rtmpgw.exe]]	--    rtmpgw.exe
	, gatewayKillCmdFlags = SW_HIDE
}

Settings['<shitFlare>'] = {
	  delCookies = false
	, cookieDonors = {
		  'http://add-anime.net/rss.php?mode=recent'
		, 'http://berwra.com/kurdish/templates/zt_newsiv/css/css3.css'
		, 'http://c-revin.com/'
		, 'http://dabashan.net/index.php?format=feed&type=rss'
		, 'http://www.kurdd.com/vb/external.php?type=RSS2'
		, 'http://l4kurd.com/index.php?format=feed&type=rss'
		, 'http://malacanang.gov.ph/feed/'
		, 'http://nijen.net/index.php/component/search/?format=opensearch'
		, 'http://pdk-zaxo.com/index.php?format=feed&type=rss'
		, 'http://ragaz.org/index.php?format=feed&type=rss'
		, 'http://renweni.com/'
		, 'http://rozhgar.net/'
		, 'http://shetaa.net/style/imports/base.css'
		, 'http://ysm21.net/extern.php?action=feed&type=rss'
		, 'http://www.znkurd.com/cms/Infrared/Infrared/glide.css'
		, 'http://1chan.ru/js/realplexor.js'
		, 'http://baykoreans.net/files/cache/zipped_xe/style_2cee2_1378659819_v0.2.css'
		, 'http://cryptosuite.org/external.php?type=RSS2'
	}
}



Settings['m'] = { interactive = false, restoreOriginalUrl = false }
Settings['multi_up_com'] = { interactive = false }
Settings['embedupload_com'] = { interactive = false, direct = false, remember = true }
Settings['uploadmirrors_com'] = { interactive = false, remember = true }
Settings['mirrorstack_com'] = { interactive = false, remember = true }
Settings['jheberg_net'] = { interactive = false, remember = true }
Settings['exoshare_com'] = { interactive = false, remember = true }
Settings['mirrorupload_net'] = { interactive = false, remember = true }
Settings['go4up_com'] = { interactive = false, remember = true }
Settings['gigamirror_com'] = { interactive = false, remember = true }
Settings['multiup_org'] = { interactive = false, remember = true }
Settings['youtube_com'] = {
      interactive = false
    , useFallbackHost = true    -- false/true/
    , skip3D = true
    , adaptiveFmts = false        --  
-- http://en.wikipedia.org/wiki/Youtube#Quality_and_codecs
    , qualityList = {38, 37, 22, 35, 34, 18, 5}  --    
    --, qualityList = {5, 18, 34, 43, 35, 44, 45, 22, 37, 38}   --    
	--, nameTemplate = '%author%-%title%'
	--, nameTemplate = function (data) return data.author end
	, delCountryBlocked = true
	, subtitles = {
		langs = {'ru','en','en-US'}
		--, translate = 'ru'	-- "     ,    ."
		--, translateSrc = 'de' --   
		, xml = false
		, srt = false
		, sbv = false
		, asrs = false --  
	}
}
Settings['dailymotion_com'] = { interactive = false, qualityList = {'hd1080', 'hd720', 'hq', 'sd', 'ld'} }
Settings['vimeo_com'] = { interactive = false, qualityList = {'original', 'hd', 'sd', 'mobile'}, codecList = {'original', 'h264', 'vp8', 'vp6'} }
Settings['grabnetworks_com'] = { tryHttp = true }
Settings['rutube_ru'] = { interactive = false, bitrate = 'max' } -- bitrate: 'max'  'min'

Settings['turbobit_net'] = {
	  extDownloader = false	--   USD   ( )
	, forceKohana = true    --  
	, mirrors = {
		  'turbobit.net/'
		, 'turbobit.pl/'
		, 'sibit.net/'
		, 'download.onejournal.ru/'
		, 'tufiles.ru/'
		, 'turbob1t.ru/'
		, 'failoobmenik.ru/'
		, {'//dlbit.net/', '.dlbit.net/'}
		, 'hitfile.net/'
		, '//turo-bit.net/'
		, '//exbit.net/'
		, {'//./', '//xn--80acmmcjdjkaga7e.xn--p1ai/'}
		, 'unextfiles.com/'
		, 'depositfiles.com.ua/'
		, 'rapidshare.kz/'
		, '//sharezoid.com/'
		, '//monstrbit.ru/'
	}
}

Settings['upsto_re'] = {lowspeed = false}	-- 5KB/s

Settings['letitbit_net'] = {
	random = false --       (  doMirrors)
	, template = 'wap' --  ,  
	-- , doMirrors = function(origUrl, mirrors) usd.setretresult('%done%') end
	--    doMirrors,         ;
	--   doMirrors    USD  ,      doMirrors
}

Settings['lenta_ru'] = {
	  interactive = false
	, qualityList = {'full_hd', 'high', 'medium', 'low'}
}

Settings['rusfolder_com'] = {
    mirrors = {
          '//rusfolder.com/', '.rusfolder.com/', '@rusfolder.com/'
        , '//rusfolder.ru/', '.rusfolder.ru/', '@rusfolder.ru/'
        , '//rusfolder.net/', '.rusfolder.net/', '@rusfolder.net/'
        , '//ifolder.ru/', '.ifolder.ru/', '@ifolder.ru/'
        , 'files.ariom.ru/'
        , '//filearchiv.ru/', '.filearchiv.ru/', '@filearchiv.ru/'
        , '//fileget.ru/', '.fileget.ru/', '@fileget.ru/'
        , '../', '.xn--80acmmcjdjkaga7e.xn--p1ai/' 
        , '//ilfolder.com/'
        , '.pspinfo.ru/' 
        , '//yapapka.com/', '.yapapka.com/', '@yapapka.com/'
        , 'files.antistarforce.com/'
        , 'files.inmix.ru/'
        , 'files.terbuny.net/'
        , 'clfile.ru/'
        , 'ixrust.ru/' 
        , 'ufolder.ru/'
        , 'load-arhiv.ru/'
        , 'piratefiles.ru/'
        , 'runningfile.ru/'
        , 'vipfile.org/'
    }
    , externalOCR = false
    --, runTorrent = [[%ComSpec% /c start "" %torrentFile%]]    --  Bittorrent-
    , runTorrentFlags = SW_SHOWMINNOACTIVE
    , saveTorrent = false
    , detectShit = false -- tmfilepacker
} 

Settings['vk_com'] = {
	  interactive = false
	, qualityList = {720, 480, 360, 240}
}


Settings['copy_com'] = {
	  direct = true
}

Settings['flickr_com'] = {
	  skipNonOriginalPics = false -- true  1 -  , 2 -  '%notfound%'
	, videoTemplate = '%author%-%id%-%title%-%width%x%height%'
	, photoTemplate = '%author%-%id%-%title%-%width%x%height%'
	--, photoTemplate = function (info) return info.title end
}

Settings['rapidgator_net'] = {
	freeDelay = 123*60	--    
	, captchaExpire = 90	-- 
}

Settings['uploaded_to'] = { freeDelay = 180*60 } 

Settings['video_yandex_ru'] = {
	  interactive = false
	, qualityList = {"mp4-m1280x720", "ogv-m1280x720", "flv-m1280x720", "mp4-m450x334", "ogv-m450x334", "flv-m450x334"}
}

Settings['rapidshare_com'] = {
      chunkedMode = false --  ;  ,          
    , chunkSize   = 1024*1024
    , chunkPause  = 1
} 

Settings['docs_google_com'] = {
      document     = 'zip'    -- docx/html/odt/pdf/rtf/txt/zip
    , presentation = 'pptx'    -- pptx/pdf/txt
    , drawings     = 'png'    -- png/pdf/svg/jpeg
    , spreadsheet  = 'xls'    -- xls/csv/ods/pdf
} 

Settings['tumblr_com'] = {
	  apiKey='fuiKNFp9vQFvjLNvx4sUwti4Yb5yGutBN4Xh10LXZhhRKjWlV4' -- Tumbo
	, skip = {'00112233445566778899aabbccddeeff'}
	, mirrors = { '.tumblr.com/', '//tmblr.co/' }
}

Settings['picasaweb_google_com'] = {
	interactive = false
	, qualityList = {38, 37, 22, 45, 44, 35, 43, 34, 18, 5}
}

Settings['billionuploads_com'] = { delCookies = false }

Settings['yadi_sk'] = {
	folderWarning = false
	, mode = 'hosts'	-- 'zusdluahttpswrapper'/'hosts'
}
--[[
For 'hosts' mode:
213.180.193.221 yadi.sk
213.180.193.25 disk.yandex.ru disk.yandex.net disk.yandex.ua disk.yandex.com
]]

Settings['bandcamp_com'] = {
	mirrors = {'//bandcamp.com/', '.bandcamp.com/'}
}

Settings['newgrounds_com'] = {qualityList={'1080p','720p','360p'}, interactive=false}
